{$A+,B-,D+,E-,F+,G+,I-,L+,N+,O-,R-,S-,V-}

UNIT Parser;

INTERFACE

USES DOS,CRT,Stuff,ExtraGraph,SPFormat,Maths,Basis,Cameras,Lights,Textures,SolidObjects,Figures,Raytrace,Messages;

VAR glSwap:STRING;
    glTrace:STRING;
    glTiff:STRING;
    glPixel:INTEGER;
    glOversample:INTEGER;
    glScanx:INTEGER;
    glScany:INTEGER;
    glScantx:INTEGER;
    glScanty:INTEGER;
    glFramex:INTEGER;
    glFramey:INTEGER;
    glMode:BYTE;
    glState:BYTE;
    glResize:RealType;
    glStereo:BOOLEAN;


FUNCTION Parse(filename:STRING;VAR rc:STRING):BOOLEAN;

PROCEDURE List;

IMPLEMENTATION

CONST maxNameLength=20;
      maxCOLORS=100;
      maxPICTURES=10;
      maxVTexture=50;
      maxSTexture=50;
      maxFig=20;

      verbose=TRUE;


      cBlank=' ';
      cBrCl=')';
      cBrOp='(';
      cCommentOff='}';
      cCommentOn='{';
      cDecimalPoint='.';
      cDigit0='0';
      cDigit9='9';
      cEOF=#1;
      cEqual='=';
      cKomma=',';
      cLetterA='A';
      cLetterZ='Z';
      cMinus='-';
      cQuote='''';
      cSemikolon=';';
      cTab=#9;
      cUnderscore='_';
      kwACTIONS='ACTIONS';
      kwAND='AND';
      kwANDNOT='ANDNOT';
      kwANDNOTSMOOTH='ANDNOTSMOOTH';
      kwANDSMOOTH='ANDSMOOTH';
      kwBOTTOM='BOTTOM';
      kwBOX='BOX';
      kwBRIGHT='BRIGHT';
      kwCAMERA='CAMERA';
      kwCENTRAL='CENTRAL';
      kwCHESS='CHESS';
      kwCOLOR='COLOR';
      kwCOLORLIST='COLORLIST';
      kwCOLORPATTERN='COLORPATTERN';
      kwCOLORS='COLORS';
      kwCONE='CONE';
      kwBEAM='BEAM';
      kwBLUR='BLUR';
      kwBLURPLANETOID='BLURPLANETOID';
      kwBUILD='BUILD';
      kwBUILDMAX='BUILDMAX';
      kwBUILDMIN='BUILDMIN';
      kwDARK='DARK';
      kwDETECT='DETECT';
      kwDIAMETER='DIAMETER';
      kwDIRECTION='DIRECTION';
      kwDISK='DISK';
      kwEND='END';
      kwFACTOR='FACTOR';
      kwFILE='FILE';
      kwFILM='FILM';
      kwFILMN='FILMN';
      kwFIGURES='FIGURES';
      kwFRAME='FRAME';
      kwHAT='HAT';
      kwHEXAGON='HEXAGON';
      kwHEXAGONN='HEXAGONN';
      kwLIGHTS='LIGHTS';
      kwLINES='LINES';
      kwLINES2='LINES2';
      kwMARBLE='MARBLE';
      kwMARBLEN='MARBLEN';
      kwMARBLENN='MARBLENN';
      kwMODE320='MODE320';
      kwMODE640='MODE640';
      kwMODE800='MODE800';
      kwMODE1024='MODE1024';
      kwMOVE1='MOVE1';
      kwMOVE2='MOVE2';
      kwMOVE='MOVE';
      kwNAME='NAME';
      kwNEWPICT='NEWPICT';
      kwNO='NO';
      kwNORMAL='NORMAL';
      kwNORMALPATTERN='NORMALPATTERN';
      kwOBJ='OBJ';
      kwOR='OR';
      kwORSMOOTH='ORSMOOTH';
      kwOVERSAMPLE='OVERSAMPLE';
      kwPART='PART';
      kwPATTERN='PATTERN';
      kwPICTURE='PICTURE';
      kwPICTURES='PICTURES';
      kwPIXELS='PIXELS';
      kwPLANETOID='PLANETOID';
      kwPLANETOIDN='PLANETOIDN';
      kwPLATINE='PLATINE';
      kwRADIUS='RADIUS';
      kwREDRAW='REDRAW';
      kwREFLECTION='REFLECTION';
      kwREFRACTION='REFRACTION';
      kwRESIZE='RESIZE';
      kwSCALARTEXTURES='SCALARTEXTURES';
      kwSCAN='SCAN';
      kwSCENE='SCENE';
      kwSHADDOWED='SHADDOWED';
      kwSHADDOWES='SHADDOWES';
      kwSHOW='SHOW';
      kwSINGLEWALL='SINGLEWALL';
      kwSIZE='SIZE';
      kwSKY='SKY';
      kwSMOOTH='SMOOTH';
      kwSPHERE='SPHERE';
      kwSPOT='SPOT';
      kwSQUARE='SQUARE';
      kwSQUAREN='SQUAREN';
      kwSTARS='STARS';
      kwSTATE='STATE';
      kwSTEREO='STEREO';
      kwSTICK='STICK';
      kwSTRUCT='STRUCT';
      kwSWAP='SWAP';
      kwTEXTURE='TEXTURE';
      kwTEXTURE1='TEXTURE1';
      kwTEXTURE2='TEXTURE2';
      kwTIFF='TIFF';
      kwTRACE='TRACE';
      kwTRANSLATION='TRANSLATION';
      kwTRANSPARENT='TRANSPARENT';
      kwTRIANGLE='TRIANGLE';
      kwTRIANGLEN='TRIANGLEN';
      kwTURN='TURN';
      kwTYPE='TYPE';
      kwUNIQUE='UNIQUE';
      kwVARS='VARS';
      kwVECTORTEXTURES='VECTORTEXTURES';
      kwWALL='WALL';
      kwWATER='WATER';
      kwWOOD='WOOD';
      kwYES='YES';
      err093='illegal STRING expression';
      err094='illegal BYTE expression';
      err095='illegal INTEGER expression';
      err096='INTEGER expression too long';
      err097='illegal REAL expression';
      err098='name expected';
      err099=kwEND+' is not allowed for names';
      err100=kwFACTOR+' only with '+kwTYPE+'('+kwFACTOR+') allowed';
      err101=kwTYPE+'('+kwFACTOR+') requires '+kwFACTOR;
      err102=kwRADIUS+' missing for this '+kwTYPE;
      err103=kwTYPE+' and '+kwVARS +'not both allowed';
      err104=kwTYPE+' or '+kwVARS+' missing';
      err105=kwRADIUS+' not allowed for this '+kwTYPE;
      err106='Operation expected';
      err107='Figur has too many parts';
      err108='at least one part requiered';
      err109=kwSMOOTH+' only for smoothed operations allowed';
      err110=kwSCENE+' Figur expected';
      err111='value for '+kwPIXELS+' out of range';
      err112='value for '+kwOVERSAMPLE+' out of range';
      err113=kwSCAN+' statement invalid';
      err114='value for '+kwSTATE+' must be '+kwNEWPICT+', '+kwOVERSAMPLE+', '+kwDETECT+' or '+kwREDRAW;
      err115='value for '+kwSHOW+' must be '+kwMODE320+', '+kwMODE640+', '+kwMODE800+' or '+kwMODE1024;
      err116=kwFRAME+' statement invalid';
      err117=kwTEXTURE1+' OR '+kwTEXTURE2+' only with in build-texture allowed';
      err118=kwPART+' only with in build-texture allowed';
      err119=kwFILE+' and '+kwPICTURE+' not both allowed';
VAR
    (*** Scenenrelevante Eintrge ***)
    nameSCENE:STRING;
    cntCOLORS:WORD;
    arCOLORS:ARRAY[1..maxCOLORS] OF
               RECORD
                   nameCOLOR:STRING[maxNameLength];
                   col:RGBColor;
                   used:BOOLEAN
               END;

    cntPICTURES:WORD;
    arPICTURES:ARRAY[1..maxPICTURES] OF
               RECORD
                   namePICTURE:STRING[maxNameLength];
                   pict:ColMat;
                   used:BOOLEAN
               END;

    cntVT:WORD;
    vTextures:ARRAY[1..maxVTexture] OF
                RECORD
                    vName:STRING[maxNameLength];
                    t:VectorTexture;
                    used:BOOLEAN;
                END;
    cntST:WORD;
    sTextures:ARRAY[1..maxSTexture] OF
                RECORD
                    sName:STRING[maxNameLength];
                    t:ScalarTexture;
                    used:BOOLEAN;
                END;
    cntF:WORD;
    Fig:ARRAY[1..maxFig] OF
                RECORD
                    fName:STRING[maxNameLength];
                    f:PartFig;
                    used:BOOLEAN;
                END;


FUNCTION Parse(filename:STRING;VAR rc:STRING):BOOLEAN;
VAR t:TEXT;
    IOR:INTEGER;
    iorStr:STRING[10];

    lineNr:WORD;

    actLine:STRING[255];


    FUNCTION PrivateGetC:CHAR;
    BEGIN
        WHILE Length(actLine)=0 DO
        BEGIN
            INC(lineNr);
            IF EOF(t) THEN
            BEGIN
                PrivateGetC:=cEOF;
                Exit
            END;
            ReadLn(t,actLine);
            IF verbose THEN
            BEGIN
                GotoXY(1,WhereY);
                Write('Line',lineNr:5);
            END;
            IOR:=IOResult;
            IF (IOR>0) THEN
            BEGIN
                PrivateGetC:=cEOF;
                Exit
            END;
            actLine:=actLine+' '
        END;
        PrivateGetC:=actLine[1];
        actLine:=Copy(actLine,2,255)
    END;

    FUNCTION GetC:CHAR;
    VAR c:CHAR;
    BEGIN
        REPEAT
            c:=PrivateGetC;
            IF c<>cCommentOn THEN
            BEGIN
                GetC:=c;
                Exit
            END
            ELSE BEGIN
                c:=PrivateGetC;
                WHILE (c<>cCommentOff) AND (c<>cEOF) DO
                      c:=PrivateGetC;
                IF c=cEOF THEN
                BEGIN
                    GetC:=c;
                    Exit
                END
            END
        UNTIL FALSE
    END;


    PROCEDURE UngetC(c:CHAR);
    BEGIN
        actLine:=c+actLine
    END;


    PROCEDURE UngetStr(s:STRING);
    BEGIN
        actLine:=s+' '+actLine
    END;


    PROCEDURE BuildRC(VAR s:STRING;error:STRING);
    VAR lineNrStr:STRING;
        dir:DirStr;
        name:NameStr;
        ext:ExtStr;
    BEGIN
        Str(lineNr,lineNrStr);
        FSplit(fileName,dir,name,ext);
        s:=name+ext+' ['+lineNrStr+']:'+error
    END;

    PROCEDURE BuildRCexpected(VAR s:STRING;s2:STRING);
    BEGIN
        BuildRC(s,'"'+s2+'" expected')
    END;

    PROCEDURE BuildRCexpected2(VAR s:STRING;s21,s22:STRING);
    BEGIN
        BuildRC(s,'"'+s21+'" or "'+s22+'" expected')
    END;

    PROCEDURE BuildRCnotfound(VAR s:STRING;name,keyword:STRING);
    BEGIN
        BuildRC(s,'...'+name+'... - '+keyword+' not found')
    END;

    PROCEDURE BuildRCunknown(VAR s:STRING;name,keyword:STRING);
    BEGIN
        BuildRC(s,'...'+name+'... - unknown '+keyword)
    END;


    PROCEDURE BuildRCexpectedkw(VAR s:STRING;name,keyword:STRING);
    BEGIN
        BuildRC(s,'...'+name+'... - Keyword '+keyword+' expected')
    END;


    PROCEDURE BuildRCalready(VAR s:STRING;keyword:STRING);
    BEGIN
        BuildRC(s,keyword+' already defined')
    END;

    PROCEDURE BuildRCmissing(VAR s:STRING;keyword:STRING);
    BEGIN
        BuildRC(s,keyword+' missing')
    END;

    PROCEDURE BuildRCtwice(VAR s:STRING;name,keyword:STRING);
    BEGIN
        BuildRC(s,'...'+name+'... - '+keyword+' defined twice')
    END;

    PROCEDURE BuildRCtoomany(VAR s:STRING;keyword:STRING);
    BEGIN
        BuildRC(s,'Too many '+keyword)
    END;


    PROCEDURE BuildRCtoolong(VAR s:STRING;name:STRING);
    BEGIN
        BuildRC(s,'...'+name+'... - name too long')
    END;


    PROCEDURE BuildRCoutofrange(VAR s:STRING);
    BEGIN
        BuildRC(s,'value out of range')
    END;


    PROCEDURE BuildRCmemovl(VAR s:STRING);
    BEGIN
        BuildRC(s,'Memory Overflow')
    END;


    PROCEDURE BuildRCfileError(VAR s:STRING;fileName:STRING;IOR:INTEGER);
    VAR IORStr:STRING;
    BEGIN
        GetResultString(IORStr,IOR);
        BuildRC(s,'FileError with '+fileName+':'+IORStr)
    END;


    PROCEDURE HelpError;
    VAR i:WORD;
    BEGIN
        IF verbose THEN
        BEGIN
            Delete(actLine,60,255);
            WriteLn(' --> ',actLine)
        END;
    END;

    PROCEDURE ReadWhiteBlanks;
    VAR c:CHAR;
    BEGIN
        c:=GetC;
        WHILE (c=cBlank) OR (c=cTab) DO
            c:=GetC;
        UngetC(c)
    END;

    PROCEDURE ReadName(VAR name:STRING);
    VAR c,upC:CHAR;
    BEGIN
        name:='';
        c:=GetC;
        upC:=UpChar(c);
        WHILE (upC>=cLetterA) AND (upC<=cLetterZ) OR (upC=cUnderscore) OR (upC>=cDigit0) AND (upC<=cDigit9) DO
        BEGIN
            name:=name+upC;
            IF Length(name)>maxNameLength THEN
                Exit;
            c:=GetC;
            upC:=UpChar(c)
        END;
        UngetC(c)
    END;

    FUNCTION ReadString(VAR s:STRING):BOOLEAN;
    VAR c:CHAR;
    BEGIN
        s:='';
        c:=GetC;
        IF c<>cQuote THEN
        BEGIN
            ReadString:=FALSE;
            ungetC(c);
            Exit;
        END;
        c:=GetC;
        WHILE (c<>cQuote) DO
        BEGIN
            s:=s+c;
            IF Length(s)>79 THEN
            BEGIN
                ReadString:=FALSE;
                Exit
            END;
            c:=GetC
        END;
        ReadString:=TRUE
    END;


    FUNCTION Parse_KEYWORD(keyword:STRING):BOOLEAN;
    VAR name:STRING;
    BEGIN
        ReadWhiteBlanks;
        ReadName(name);
        ReadWhiteBlanks;
        UpString(name);
        IF keyword<>name THEN
        BEGIN
            BuildRCexpectedkw(rc,name,keyword);
            Parse_KEYWORD:=FALSE;
            Exit
        END;
        Parse_KEYWORD:=TRUE
    END;


    FUNCTION Test_KEYWORD(keyword:STRING):BOOLEAN;
    VAR name,nameUp:STRING;
    BEGIN
        ReadWhiteBlanks;
        ReadName(name);
        nameUp:=name;
        UpString(nameUp);
        IF keyword<>nameUp THEN
        BEGIN
            UngetStr(name);
            BuildRCexpectedkw(rc,nameUp,keyword);
            Test_KEYWORD:=FALSE;
            Exit
        END;
        ReadWhiteBlanks;
        Test_KEYWORD:=TRUE
    END;


    FUNCTION Parse_NAME(VAR name:STRING):BYTE;
    BEGIN
        ReadWhiteBlanks;
        ReadName(name);
        ReadWhiteBlanks;
        UpString(name);
        IF name='' THEN
        BEGIN
            BuildRC(rc,err098);
            Parse_NAME:=0;
            Exit
        END;
        IF Length(name)>maxNameLength THEN
        BEGIN
            BuildRCtoolong(rc,name);
            Parse_NAME:=0;
            Exit
        END;
        IF name=kwEND THEN
        BEGIN
            BuildRC(rc,err099);
            UngetStr(name);
            Parse_NAME:=2;
            Exit
        END
        ELSE
            Parse_NAME:=1
    END;


    FUNCTION Parse_STRING(VAR s:STRING):BOOLEAN;
    BEGIN
        ReadWhiteBlanks;
        IF NOT ReadSTRING(s) THEN
        BEGIN
            BuildRC(rc,err093);
            Parse_STRING:=FALSE;
        END;
        ReadWhiteBlanks;
        Parse_STRING:=TRUE;
    END;


    FUNCTION Parse_REAL(VAR r:RealType):BOOLEAN;
    VAR c:CHAR;
        negFlag:BOOLEAN;
        aDigit:BOOLEAN;
        fract:RealType;
    BEGIN
        ReadWhiteBlanks;
        r:=0;
        c:=GetC;
        IF c=cMinus THEN
        BEGIN
            negFlag:=TRUE;
            c:=GetC
        END
        ELSE
            negFlag:=FALSE;
        aDigit:=FALSE;

        WHILE (c>=cDigit0) AND (c<=cDigit9) DO
        BEGIN
            aDigit:=TRUE;
            r:=r*10+(ORD(c)-ORD(cDigit0));
            c:=GetC
        END;
        IF NOT aDigit THEN
        BEGIN
            BuildRC(rc,err097);
            Parse_REAL:=FALSE;
            Exit
        END;
        IF c=cDecimalPoint THEN
        BEGIN
            fract:=0.1;
            c:=GetC;
            WHILE (c>=cDigit0) AND (c<=cDigit9) DO
            BEGIN
                r:=r+fract*(ORD(c)-ORD(cDigit0));
                fract:=fract/10;
                c:=GetC
            END;
        END;
        UngetC(c);
        IF negFlag THEN
            r:=-r;
        ReadWhiteBlanks;
        Parse_REAL:=TRUE
    END;


    FUNCTION Parse_LONG(VAR l:LONGINT):BOOLEAN;
    VAR c:CHAR;
        negFlag:BOOLEAN;
        aDigit:BOOLEAN;
    BEGIN
        ReadWhiteBlanks;
        l:=0;
        c:=GetC;
        IF c=cMinus THEN
        BEGIN
            negFlag:=TRUE;
            c:=GetC
        END
        ELSE
            negFlag:=FALSE;
        aDigit:=FALSE;

        WHILE (c>=cDigit0) AND (c<=cDigit9) DO
        BEGIN
            aDigit:=TRUE;
            IF l>MAXLONGINT DIV 10 THEN
            BEGIN
                BuildRC(rc,err096);
                Parse_LONG:=FALSE;
                Exit
            END;
            l:=l*10+(ORD(c)-ORD(cDigit0));
            c:=GetC
        END;
        IF NOT aDigit THEN
        BEGIN
            BuildRC(rc,err095);
            Parse_LONG:=FALSE;
            Exit
        END;
        UngetC(c);
        IF negFlag THEN
            l:=-l;
        ReadWhiteBlanks;
        Parse_LONG:=TRUE
    END;


    FUNCTION Parse_INT(VAR int:INTEGER):BOOLEAN;
    VAR l:LONGINT;
        lStr:STRING[20];
    BEGIN
        IF NOT Parse_LONG(l) THEN
        BEGIN
            Parse_INT:=FALSE;
            Exit;
        END;
        IF (l<-32767) OR (l>32767) THEN
        BEGIN
            Str(l,lStr);
            BuildRC(rc,err095);
            Parse_INT:=FALSE;
            Exit
        END;
        int:=l;
        Parse_INT:=TRUE
    END;



    FUNCTION Parse_BYTE(VAR b:BYTE):BOOLEAN;
    VAR l:LONGINT;
        lStr:STRING[20];
    BEGIN
        IF NOT Parse_LONG(l) THEN
        BEGIN
            Parse_BYTE:=FALSE;
            Exit;
        END;
        IF (l<0) OR (l>255) THEN
        BEGIN
            Str(l,lStr);
            BuildRC(rc,err094);
            Parse_BYTE:=FALSE;
            Exit
        END;
        b:=l;
        Parse_BYTE:=TRUE
    END;

    FUNCTION Parse_Semikolon:BOOLEAN;
    VAR c:CHAR;
    BEGIN
        ReadWhiteBlanks;
        c:=GetC;
        ReadWhiteBlanks;
        IF c<>cSemikolon THEN
        BEGIN
            BuildRCexpected(rc,cSemikolon);
            Parse_Semikolon:=FALSE;
            Exit
        END;
        Parse_Semikolon:=TRUE
    END;

    FUNCTION Parse_Eq:BOOLEAN;
    VAR c:CHAR;
    BEGIN
        ReadWhiteBlanks;
        c:=GetC;
        ReadWhiteBlanks;
        IF c<>cEqual THEN
        BEGIN
            BuildRCexpected(rc,cEqual);
            Parse_Eq:=FALSE;
            Exit
        END;
        Parse_Eq:=TRUE
    END;


    FUNCTION Parse_EqBr:BOOLEAN;
    VAR c1,c2:CHAR;
    BEGIN
        ReadWhiteBlanks;
        c1:=GetC;
        ReadWhiteBlanks;
        c2:=GetC;
        ReadWhiteBlanks;
        IF c1<>cEqual THEN
        BEGIN
            BuildRCexpected(rc,cEqual);
            Parse_EqBr:=FALSE;
            Exit
        END;
        IF c2<>cBrOp THEN
        BEGIN
            BuildRCexpected(rc,cBrOp);
            Parse_EqBr:=FALSE;
            Exit
        END;
        Parse_EqBr:=TRUE
    END;


    FUNCTION Parse_BrSemikolon:BOOLEAN;
    VAR c1,c2:CHAR;
    BEGIN
        ReadWhiteBlanks;
        c1:=GetC;
        ReadWhiteBlanks;
        c2:=GetC;
        ReadWhiteBlanks;
        IF c1<>cBrCl THEN
        BEGIN
            BuildRCexpected(rc,cBrCl);
            Parse_BrSemikolon:=FALSE;
            Exit
        END;
        IF c2<>cSemikolon THEN
        BEGIN
            BuildRCexpected(rc,cSemikolon);
            Parse_BrSemikolon:=FALSE;
            Exit
        END;
        Parse_BrSemikolon:=TRUE
    END;


    FUNCTION Parse_ClBr:BOOLEAN;
    VAR c:CHAR;
    BEGIN
        ReadWhiteBlanks;
        c:=GetC;
        ReadWhiteBlanks;
        IF c<>cBrCl THEN
        BEGIN
            BuildRCexpected(rc,cBrCl);
            Parse_ClBr:=FALSE;
            Exit
        END;
        Parse_ClBr:=TRUE
    END;


    FUNCTION Test_ClBr:BOOLEAN;
    VAR c:CHAR;
    BEGIN
        ReadWhiteBlanks;
        c:=GetC;
        IF c<>cBrCl THEN
        BEGIN
            UngetC(c);
            Test_ClBr:=FALSE;
            Exit
        END;
        ReadWhiteBlanks;
        Test_ClBr:=TRUE
    END;


    FUNCTION Parse_OpBr:BOOLEAN;
    VAR c:CHAR;
    BEGIN
        ReadWhiteBlanks;
        c:=GetC;
        ReadWhiteBlanks;
        IF c<>cBrOp THEN
        BEGIN
            BuildRCexpected(rc,cBrOp);
            Parse_OpBr:=FALSE;
            Exit
        END;
        Parse_OpBr:=TRUE
    END;

    FUNCTION Parse_Komma:BOOLEAN;
    VAR c:CHAR;
    BEGIN
        ReadWhiteBlanks;
        c:=GetC;
        ReadWhiteBlanks;
        IF c<>cKomma THEN
        BEGIN
            BuildRCexpected(rc,cKomma);
            Parse_Komma:=FALSE;
            Exit
        END;
        Parse_Komma:=TRUE
    END;

    FUNCTION Test_Komma:BOOLEAN;
    VAR c:CHAR;
    BEGIN
        ReadWhiteBlanks;
        c:=GetC;
        IF c<>cKomma THEN
        BEGIN
            UngetC(c);
            Test_Komma:=FALSE;
            Exit
        END;
        ReadWhiteBlanks;
        Test_Komma:=TRUE
    END;

    FUNCTION Test_Single(keyword:STRING;VAR v:RealType;VAR error:BOOLEAN):BOOLEAN;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_Single:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_Single:=TRUE;
            EXIT
        END;
        IF NOT Parse_REAL(v) THEN
        BEGIN
            Test_Single:=TRUE;
            EXIT
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_Single:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_Single:=TRUE
    END;

    FUNCTION Test_SingleBYTE(keyword:STRING;VAR v:BYTE;VAR error:BOOLEAN):BOOLEAN;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_SingleBYTE:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_SingleBYTE:=TRUE;
            EXIT
        END;
        IF NOT Parse_BYTE(v) THEN
        BEGIN
            Test_SingleBYTE:=TRUE;
            EXIT
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_SingleBYTE:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_SingleBYTE:=TRUE
    END;

    FUNCTION Test_SingleBool(keyword:STRING;VAR b:BOOLEAN;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_SingleBool:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_SingleBool:=TRUE;
            EXIT
        END;
        IF NOT (Parse_NAME(name)=1) THEN
        BEGIN
            Test_SingleBool:=TRUE;
            EXIT
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_SingleBool:=TRUE;
            EXIT
        END;
        IF name=kwYES THEN
            b:=TRUE
        ELSE IF name=kwNO THEN
            b:=FALSE
        ELSE BEGIN
            BuildRCexpected2(rc,kwYES,kwNO);
            Test_SingleBool:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_SingleBool:=TRUE
    END;


    FUNCTION Test_SingleName(keyword:STRING;VAR s:STRING;VAR error:BOOLEAN):BOOLEAN;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_SingleName:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_SingleName:=TRUE;
            EXIT
        END;
        IF NOT (Parse_NAME(s)=1) THEN
        BEGIN
            Test_SingleName:=TRUE;
            EXIT
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_SingleName:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_SingleName:=TRUE
    END;

    FUNCTION Test_SingleString(keyword:STRING;VAR s:STRING;VAR error:BOOLEAN):BOOLEAN;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_SingleString:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_SingleString:=TRUE;
            EXIT
        END;
        IF NOT (Parse_String(s)) THEN
        BEGIN
            Test_SingleString:=TRUE;
            EXIT
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_SingleString:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_SingleString:=TRUE
    END;


    FUNCTION Test_Color(VAR col:RGBColor;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
        found:BOOLEAN;
        i:WORD;
    BEGIN
        IF NOT Test_KEYWORD(kwCOLOR) THEN
        BEGIN
            error:=FALSE;
            Test_Color:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_Color:=TRUE;
            EXIT
        END;
        IF NOT (Parse_Name(name)=1) THEN
        BEGIN
            Test_Color:=TRUE;
            EXIT
        END;
        found:=FALSE;
        FOR i:=1 TO cntCOLORS DO
            IF name=arCOLORS[i].nameCOLOR THEN
            BEGIN
                col:=arCOLORS[i].col;
                arCOLORS[i].used:=TRUE;
                found:=TRUE
            END;
        IF NOT found THEN
        BEGIN
            BuildRCnotfound(rc,name,kwCOLOR);
            Test_Color:=TRUE;
            EXIT
        END;

        IF NOT Parse_ClBr THEN
        BEGIN
            Test_Color:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_Color:=TRUE
    END;

    FUNCTION Test_Picture(VAR pict:ColMat;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
        found:BOOLEAN;
        i:WORD;
    BEGIN
        IF NOT Test_KEYWORD(kwPICTURE) THEN
        BEGIN
            error:=FALSE;
            Test_Picture:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_Picture:=TRUE;
            EXIT
        END;
        IF NOT (Parse_Name(name)=1) THEN
        BEGIN
            Test_Picture:=TRUE;
            EXIT
        END;
        found:=FALSE;
        FOR i:=1 TO cntPICTURES DO
            IF name=arPICTURES[i].namePICTURE THEN
            BEGIN
                pict:=arPICTURES[i].pict;
                arPICTURES[i].used:=TRUE;
                found:=TRUE
            END;
        IF NOT found THEN
        BEGIN
            BuildRCnotfound(rc,name,kwPICTURE);
            Test_Picture:=TRUE;
            EXIT
        END;

        IF NOT Parse_ClBr THEN
        BEGIN
            Test_Picture:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_Picture:=TRUE
    END;



    FUNCTION Test_DoubleNameReal(keyword:STRING;VAR vara:STRING;VAR varb:RealType;VAR error:BOOLEAN):BOOLEAN;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_DoubleNameReal:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_DoubleNameReal:=TRUE;
            EXIT
        END;
        IF NOT (Parse_NAME(vara)=1) THEN
        BEGIN
            Test_DoubleNameReal:=TRUE;
            EXIT
        END;
        IF NOT Parse_Komma THEN
        BEGIN
            Test_DoubleNameReal:=TRUE;
            EXIT
        END;
        IF NOT Parse_REAL(varb) THEN
        BEGIN
            Test_DoubleNameReal:=TRUE;
            EXIT
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_DoubleNameReal:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_DoubleNameReal:=TRUE
    END;

    FUNCTION Test_DoubleRealReal(keyword:STRING;VAR vara,varb:RealType;VAR error:BOOLEAN):BOOLEAN;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_DoubleRealReal:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_DoubleRealReal:=TRUE;
            EXIT
        END;
        IF NOT Parse_REAL(vara) THEN
        BEGIN
            Test_DoubleRealReal:=TRUE;
            EXIT
        END;
        IF NOT Parse_Komma THEN
        BEGIN
            Test_DoubleRealReal:=TRUE;
            EXIT
        END;
        IF NOT Parse_REAL(varb) THEN
        BEGIN
            Test_DoubleRealReal:=TRUE;
            EXIT
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_DoubleRealReal:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_DoubleRealReal:=TRUE
    END;

    FUNCTION Test_6Real(keyword:STRING;VAR vara,varb,varc,vard,vare,varf:RealType;VAR error:BOOLEAN):BOOLEAN;
    VAR i:WORD;
        vars:ARRAY[1..6] OF RealType;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_6Real:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_6Real:=TRUE;
            EXIT
        END;
        FOR i:=1 TO 6 DO
        BEGIN
            IF NOT Parse_REAL(vars[i]) THEN
            BEGIN
                Test_6Real:=TRUE;
                EXIT
            END;
            IF i<6 THEN
            BEGIN
               IF NOT Parse_Komma THEN
                BEGIN
                   Test_6Real:=TRUE;
                   EXIT
                END
            END
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_6Real:=TRUE;
            EXIT
        END;
        vara:=vars[1];
        varb:=vars[2];
        varc:=vars[3];
        vard:=vars[4];
        vare:=vars[5];
        varf:=vars[6];
        error:=FALSE;
        Test_6Real:=TRUE
    END;



    FUNCTION Test_7Real(keyword:STRING;VAR vara,varb,varc,vard,vare,varf,varg:RealType;VAR error:BOOLEAN):BOOLEAN;
    VAR i:WORD;
        vars:ARRAY[1..7] OF RealType;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_7Real:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_7Real:=TRUE;
            EXIT
        END;
        FOR i:=1 TO 7 DO
        BEGIN
            IF NOT Parse_REAL(vars[i]) THEN
            BEGIN
                Test_7Real:=TRUE;
                EXIT
            END;
            IF i<7 THEN
            BEGIN
               IF NOT Parse_Komma THEN
                BEGIN
                   Test_7Real:=TRUE;
                   EXIT
                END
            END
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_7Real:=TRUE;
            EXIT
        END;
        vara:=vars[1];
        varb:=vars[2];
        varc:=vars[3];
        vard:=vars[4];
        vare:=vars[5];
        varf:=vars[6];
        varg:=vars[7];
        error:=FALSE;
        Test_7Real:=TRUE
    END;


    FUNCTION Test_4Int(keyword:STRING;VAR vara,varb,varc,vard:INTEGER;VAR error:BOOLEAN):BOOLEAN;
    VAR i:WORD;
        vars:ARRAY[1..4] OF INTEGER;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_4Int:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_4Int:=TRUE;
            EXIT
        END;
        FOR i:=1 TO 4 DO
        BEGIN
            IF NOT Parse_INT(vars[i]) THEN
            BEGIN
                Test_4Int:=TRUE;
                EXIT
            END;
            IF i<4 THEN
            BEGIN
               IF NOT Parse_Komma THEN
                BEGIN
                   Test_4Int:=TRUE;
                   EXIT
                END
            END
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_4Int:=TRUE;
            EXIT
        END;
        vara:=vars[1];
        varb:=vars[2];
        varc:=vars[3];
        vard:=vars[4];
        error:=FALSE;
        Test_4Int:=TRUE
    END;


    FUNCTION Test_2Int(keyword:STRING;VAR vara,varb:INTEGER;VAR error:BOOLEAN):BOOLEAN;
    VAR i:WORD;
        vars:ARRAY[1..2] OF INTEGER;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_2Int:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_2Int:=TRUE;
            EXIT
        END;
        FOR i:=1 TO 2 DO
        BEGIN
            IF NOT Parse_INT(vars[i]) THEN
            BEGIN
                Test_2Int:=TRUE;
                EXIT
            END;
            IF i<2 THEN
            BEGIN
               IF NOT Parse_Komma THEN
                BEGIN
                   Test_2Int:=TRUE;
                   EXIT
                END
            END
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_2Int:=TRUE;
            EXIT
        END;
        vara:=vars[1];
        varb:=vars[2];
        error:=FALSE;
        Test_2Int:=TRUE
    END;



    FUNCTION Test_Tripple(keyword:STRING;VAR vara,varb,varc:RealType;VAR error:BOOLEAN):BOOLEAN;
    BEGIN
        IF NOT Test_KEYWORD(keyword) THEN
        BEGIN
            error:=FALSE;
            Test_Tripple:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_Tripple:=TRUE;
            EXIT
        END;
        IF NOT Parse_REAL(vara) THEN
        BEGIN
            Test_Tripple:=TRUE;
            EXIT
        END;
        IF NOT Parse_Komma THEN
        BEGIN
            Test_Tripple:=TRUE;
            EXIT
        END;
        IF NOT Parse_REAL(varb) THEN
        BEGIN
            Test_Tripple:=TRUE;
            EXIT
        END;
        IF NOT Parse_Komma THEN
        BEGIN
            Test_Tripple:=TRUE;
            EXIT
        END;
        IF NOT Parse_REAL(varc) THEN
        BEGIN
            Test_Tripple:=TRUE;
            EXIT
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_Tripple:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_Tripple:=TRUE
    END;


    FUNCTION Parse_TRANSLATION(VAR mx,my,mz,ta,tb,tc,sx,sy,sz:RealType;allowSize:BOOLEAN;VAR error:BOOLEAN):BOOLEAN;
    VAR isMOVE,isTURN,isSIZE:BOOLEAN;
        finish:BOOLEAN;
        err:BOOLEAN;
    BEGIN
        mx:=0;
        my:=0;
        mz:=0;
        ta:=0;
        tb:=0;
        tc:=0;
        isMOVE:=FALSE;
        isTURN:=FALSE;
        isSIZE:=FALSE;
        IF NOT Parse_KEYWORD(kwTRANSLATION) THEN
        BEGIN
            error:=FALSE;
            Parse_TRANSLATION:=FALSE;
            Exit
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Parse_TRANSLATION:=FALSE;
            Exit
        END;
        REPEAT
            IF Test_Tripple(kwMOVE,mx,my,mz,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_TRANSLATION:=FALSE;
                    Exit
                END;
                IF isMOVE THEN
                BEGIN
                    BuildRCalready(rc,kwMOVE);
                    Parse_TRANSLATION:=FALSE;
                    Exit
                END;
                isMOVE:=TRUE 
            END
            ELSE IF Test_Tripple(kwTURN,ta,tb,tc,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_TRANSLATION:=FALSE;
                    Exit
                END;
                IF isTURN THEN
                BEGIN
                    BuildRCalready(rc,kwTURN);
                    Parse_TRANSLATION:=FALSE;
                    Exit
                END;
                isTURN:=TRUE
            END
            ELSE IF allowSize AND Test_Tripple(kwSIZE,sx,sy,sz,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_TRANSLATION:=FALSE;
                    Exit
                END;
                IF isSIZE THEN
                BEGIN
                    BuildRCalready(rc,kwSIZE);
                    Parse_TRANSLATION:=FALSE;
                    Exit
                END;
                isSIZE:=TRUE
            END
            ELSE BEGIN
                Parse_TRANSLATION:=FALSE;
                Exit
            END;
            IF Test_Komma THEN
                finish:=FALSE
            ELSE IF Test_ClBr THEN
                finish:=TRUE
            ELSE BEGIN
                BuildRCexpected2(rc,cKomma,cBrCl);
                Parse_TRANSLATION:=FALSE;
                Exit
            END
        UNTIL finish;
        error:=FALSE;
        Parse_TRANSLATION:=TRUE
    END;


    FUNCTION Test_TRANSLATION(VAR mx,my,mz,ta,tb,tc,sx,sy,sz:RealType;allowSize:BOOLEAN;VAR error:BOOLEAN):BOOLEAN;
    VAR tst:BOOLEAN;
    BEGIN
        IF NOT Test_KEYWORD(kwTRANSLATION) THEN
        BEGIN
            error:=FALSE;
            Test_TRANSLATION:=FALSE;
            EXIT
        END;
        UngetStr(kwTRANSLATION);
        tst:=Parse_TRANSLATION(mx,my,mz,ta,tb,tc,sx,sy,sz,allowSize,error);
        Test_TRANSLATION:=TRUE
    END;


    FUNCTION Parse_SCENE:BOOLEAN;
    BEGIN
        IF NOT Parse_KEYWORD(kwSCENE) THEN
        BEGIN
            Parse_SCENE:=FALSE;
            Exit
        END;
        IF Parse_NAME(nameSCENE)<>1 THEN
        BEGIN
            Parse_SCENE:=FALSE;
            Exit
        END;
        IF NOT Parse_Semikolon THEN
        BEGIN
            Parse_SCENE:=FALSE;
            Exit
        END;
        Parse_SCENE:=TRUE
    END;

    FUNCTION Parse_COLORS:BOOLEAN;
    VAR name:STRING;
        res:BYTE;
        found:BOOLEAN;
        i:WORD;
    BEGIN
        cntCOLORS:=0;
        IF NOT Parse_KEYWORD(kwCOLORS) THEN
        BEGIN
            Parse_COLORS:=FALSE;
            Exit
        END;

        res:=Parse_NAME(name);
        WHILE res=1 DO
        BEGIN
            found:=FALSE;
            FOR i:=1 TO cntCOLORS DO
                IF name=arCOLORS[i].nameCOLOR THEN
                    found:=TRUE;
            IF found THEN
            BEGIN
                BuildRCtwice(rc,name,kwCOLOR);
                Parse_COLORS:=FALSE;
                EXIT
            END;

            INC(cntCOLORS);
            IF cntCOLORS>maxCOLORS THEN
            BEGIN
                BuildRCtoomany(rc,kwCOLOR);
                Parse_COLORS:=FALSE;
                Exit
            END;

            arCOLORS[cntCOLORS].nameCOLOR:=name;
            arCOLORS[cntCOLORS].used:=FALSE;

            IF NOT Parse_EqBr THEN
            BEGIN
                Parse_COLORS:=FALSE;
                Exit
            END;

            IF NOT Parse_BYTE(arCOLORS[cntCOLORS].col.r) THEN
            BEGIN
                Parse_COLORS:=FALSE;
                Exit
            END;

            IF NOT Parse_Komma THEN
            BEGIN
                Parse_COLORS:=FALSE;
                Exit
            END;

            IF NOT Parse_BYTE(arCOLORS[cntCOLORS].col.g) THEN
            BEGIN
                Parse_COLORS:=FALSE;
                Exit
            END;

            IF NOT Parse_Komma THEN
            BEGIN
                Parse_COLORS:=FALSE;
                Exit
            END;

            IF NOT Parse_BYTE(arCOLORS[cntCOLORS].col.b) THEN
            BEGIN
                Parse_COLORS:=FALSE;
                Exit
            END;

            IF NOT Parse_BrSemikolon THEN
            BEGIN
                Parse_COLORS:=FALSE;
                Exit
            END;

            res:=Parse_NAME(name);
        END;

        IF res=2 THEN
        BEGIN
            IF Parse_KEYWORD(kwEND) THEN
            BEGIN
                Parse_COLORS:=TRUE;
                Exit
            END
            ELSE BEGIN
                Parse_COLORS:=FALSE;
                Exit
            END
        END
        ELSE BEGIN
            Parse_COLORS:=FALSE;
            Exit
        END
    END;

    FUNCTION Parse_CAMERA:BOOLEAN;
    VAR ta,tb,tc:RealType;
        v:Vector3;
        dummy:RealType;
        err:BOOLEAN;
    BEGIN
        IF NOT Parse_KEYWORD(kwCAMERA) THEN
        BEGIN
            Parse_CAMERA:=FALSE;
            Exit
        END;
        IF NOT Parse_Eq THEN
        BEGIN
            Parse_CAMERA:=FALSE;
            Exit
        END;
        IF NOT Parse_TRANSLATION(v.x,v.y,v.z,ta,tb,tc,dummy,dummy,dummy,FALSE,err) THEN
        BEGIN
            Parse_CAMERA:=FALSE;
            Exit
        END;
        IF NOT Parse_Semikolon THEN
        BEGIN
            Parse_CAMERA:=FALSE;
            Exit
        END;
        Parse_CAMERA:=TRUE;

        SetCamera(v);
        TurnDegCamera(ta,tb,tc);

    END;


    FUNCTION Parse_LIGHT_NORMAL:BOOLEAN;
    VAR ll:Vector3;
        ff:RealType;
        col:RGBColor;
        isDIRECTION:BOOLEAN;
        isPART:BOOLEAN;
        isCOLOR:BOOLEAN;
        finish:BOOLEAN;
        err:BOOLEAN;
    BEGIN
        IF NOT Parse_OpBr THEN
        BEGIN
            Parse_LIGHT_NORMAL:=FALSE;
            Exit
        END;
        isDIRECTION:=FALSE;
        isPART:=FALSE;
        isCOLOR:=FALSE;
        col.r:=255;
        col.g:=255;
        col.b:=255;
        ll.x:=0;
        ll.y:=-1;
        ll.z:=1;
        ff:=1;
        REPEAT
            IF Test_Tripple(kwDIRECTION,ll.x,ll.y,ll.z,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_NORMAL:=FALSE;
                    Exit
                END;
                IF isDIRECTION THEN
                BEGIN
                    BuildRCalready(rc,kwDIRECTION);
                    Parse_LIGHT_NORMAL:=FALSE;
                    Exit
                END;
                isDIRECTION:=TRUE
            END
            ELSE IF Test_Single(kwPART,ff,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_NORMAL:=FALSE;
                    Exit
                END;
                IF isPART THEN
                BEGIN
                    BuildRCalready(rc,kwPART);
                    Parse_LIGHT_NORMAL:=FALSE;
                    Exit
                END;
                IF ff<=0 THEN
                BEGIN
                    BuildRCoutofrange(rc);
                    Parse_LIGHT_NORMAL:=FALSE;
                    Exit
                END;
                isPART:=TRUE
            END
            ELSE IF Test_Color(col,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_NORMAL:=FALSE;
                    Exit
                END;
                IF isCOLOR THEN
                BEGIN
                    BuildRCalready(rc,kwCOLOR);
                    Parse_LIGHT_NORMAL:=FALSE;
                    Exit
                END;
                isCOLOR:=TRUE
            END
            ELSE BEGIN
                Parse_LIGHT_NORMAL:=FALSE;
                Exit
            END;
            IF Test_Komma THEN
                finish:=FALSE
            ELSE IF Test_ClBr THEN
                finish:=TRUE
            ELSE BEGIN
                BuildRCexpected2(rc,cKomma,cBrCl);
                Parse_LIGHT_NORMAL:=FALSE;
                Exit
            END
        UNTIL finish;
        IF NOT Parse_Semikolon THEN
        BEGIN
            BuildRCexpected(rc,cSemikolon);
            Parse_LIGHT_NORMAL:=FALSE;
            Exit
        END;
        SetLightNormal(ll,ff,col);
        Parse_LIGHT_NORMAL:=TRUE
    END;

    FUNCTION Parse_LIGHT_CENTRAL:BOOLEAN;
    VAR cc:Vector3;
        darkIndex:RealType;
        ff:RealType;
        col:RGBColor;
        isMOVE:BOOLEAN;
        isDARK:BOOLEAN;
        isPART:BOOLEAN;
        isCOLOR:BOOLEAN;
        finish:BOOLEAN;
        err:BOOLEAN;
    BEGIN
        IF NOT Parse_OpBr THEN
        BEGIN
            Parse_LIGHT_CENTRAL:=FALSE;
            Exit
        END;
        isMOVE:=FALSE;
        isDARK:=FALSE;
        isPART:=FALSE;
        isCOLOR:=FALSE;
        col.r:=255;
        col.g:=255;
        col.b:=255;
        cc.x:=0;
        cc.y:=1000;
        cc.z:=0;
        ff:=1;
        darkIndex:=0;
        REPEAT
            IF Test_Tripple(kwMOVE,cc.x,cc.y,cc.z,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_CENTRAL:=FALSE;
                    Exit
                END;
                IF isMOVE THEN
                BEGIN
                    BuildRCalready(rc,kwMOVE);
                    Parse_LIGHT_CENTRAL:=FALSE;
                    Exit
                END;
                isMOVE:=TRUE
            END
            ELSE IF Test_Single(kwPART,ff,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_CENTRAL:=FALSE;
                    Exit
                END;
                IF isPART THEN
                BEGIN
                    BuildRCalready(rc,kwPART);
                    Parse_LIGHT_CENTRAL:=FALSE;
                    Exit
                END;
                IF ff<=0 THEN
                BEGIN
                    BuildRCoutofrange(rc);
                    Parse_LIGHT_CENTRAL:=FALSE;
                    Exit
                END;
                isPART:=TRUE
            END
            ELSE IF Test_Single(kwDARK,darkIndex,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_CENTRAL:=FALSE;
                    Exit
                END;
                IF isDARK THEN
                BEGIN
                    BuildRCalready(rc,kwDARK);
                    Parse_LIGHT_CENTRAL:=FALSE;
                    Exit
                END;
                IF darkIndex<0 THEN
                BEGIN
                    BuildRCoutofrange(rc);
                    Parse_LIGHT_CENTRAL:=FALSE;
                    Exit
                END;
                isDARK:=TRUE
            END
            ELSE IF Test_Color(col,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_CENTRAL:=FALSE;
                    Exit
                END;
                IF isCOLOR THEN
                BEGIN
                    BuildRCalready(rc,kwCOLOR);
                    Parse_LIGHT_CENTRAL:=FALSE;
                    Exit
                END;
                isCOLOR:=TRUE
            END
            ELSE BEGIN
                Parse_LIGHT_CENTRAL:=FALSE;
                Exit
            END;
            IF Test_Komma THEN
                finish:=FALSE
            ELSE IF Test_ClBr THEN
                finish:=TRUE
            ELSE BEGIN
                BuildRCexpected2(rc,cKomma,cBrCl);
                Parse_LIGHT_CENTRAL:=FALSE;
                Exit
            END
        UNTIL finish;
        IF NOT Parse_Semikolon THEN
        BEGIN
            BuildRCexpected(rc,cSemikolon);
            Parse_LIGHT_CENTRAL:=FALSE;
            Exit
        END;
        SetLightCentral(cc,darkIndex,ff,col);
        Parse_LIGHT_CENTRAL:=TRUE
    END;

    FUNCTION Parse_LIGHT_STICK:BOOLEAN;
    VAR cc1,cc2:Vector3;
        darkIndex:RealType;
        ff:RealType;
        col:RGBColor;
        isMOVE1:BOOLEAN;
        isMOVE2:BOOLEAN;
        isDARK:BOOLEAN;
        isPART:BOOLEAN;
        isCOLOR:BOOLEAN;
        finish:BOOLEAN;
        err:BOOLEAN;
    BEGIN
        IF NOT Parse_OpBr THEN
        BEGIN
            Parse_LIGHT_STICK:=FALSE;
            Exit
        END;
        isMOVE1:=FALSE;
        isMOVE2:=FALSE;
        isDARK:=FALSE;
        isPART:=FALSE;
        isCOLOR:=FALSE;
        col.r:=255;
        col.g:=255;
        col.b:=255;
        cc1.x:=100;
        cc1.y:=1000;
        cc1.z:=0;
        cc2.x:=-100;
        cc2.y:=1000;
        cc2.z:=0;
        ff:=1;
        darkIndex:=0;
        REPEAT
            IF Test_Tripple(kwMOVE1,cc1.x,cc1.y,cc1.z,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                IF isMOVE1 THEN
                BEGIN
                    BuildRCalready(rc,kwMOVE1);
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                isMOVE1:=TRUE
            END
            ELSE IF Test_Tripple(kwMOVE2,cc2.x,cc2.y,cc2.z,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                IF isMOVE2 THEN
                BEGIN
                    BuildRCalready(rc,kwMOVE2);
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                isMOVE2:=TRUE
            END
            ELSE IF Test_Single(kwPART,ff,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                IF isPART THEN
                BEGIN
                    BuildRCalready(rc,kwPART);
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                IF ff<=0 THEN
                BEGIN
                    BuildRCoutofrange(rc);
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                isPART:=TRUE
            END
            ELSE IF Test_Single(kwDARK,darkIndex,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                IF isDARK THEN
                BEGIN
                    BuildRCalready(rc,kwDARK);
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                IF darkIndex<0 THEN
                BEGIN
                    BuildRCoutofrange(rc);
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                isDARK:=TRUE
            END
            ELSE IF Test_Color(col,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                IF isCOLOR THEN
                BEGIN
                    BuildRCalready(rc,kwCOLOR);
                    Parse_LIGHT_STICK:=FALSE;
                    Exit
                END;
                isCOLOR:=TRUE
            END
            ELSE BEGIN
                Parse_LIGHT_STICK:=FALSE;
                Exit
            END;
            IF Test_Komma THEN
                finish:=FALSE
            ELSE IF Test_ClBr THEN
                finish:=TRUE
            ELSE BEGIN
                BuildRCexpected2(rc,cKomma,cBrCl);
                Parse_LIGHT_STICK:=FALSE;
                Exit
            END
        UNTIL finish;
        IF NOT Parse_Semikolon THEN
        BEGIN
            BuildRCexpected(rc,cSemikolon);
            Parse_LIGHT_STICK:=FALSE;
            Exit
        END;
        SetLightStick(cc1,cc2,darkIndex,ff,col);
        Parse_LIGHT_STICK:=TRUE
    END;

    FUNCTION Parse_LIGHT_SPOT:BOOLEAN;
    VAR cc,ll:Vector3;
        brightIndex:RealType;
        darkIndex:RealType;
        ff:RealType;
        col:RGBColor;
        isMOVE:BOOLEAN;
        isDIRECTION:BOOLEAN;
        isDARK:BOOLEAN;
        isBRIGHT:BOOLEAN;
        isPART:BOOLEAN;
        isCOLOR:BOOLEAN;
        finish:BOOLEAN;
        err:BOOLEAN;
    BEGIN
        IF NOT Parse_OpBr THEN
        BEGIN
            Parse_LIGHT_SPOT:=FALSE;
            Exit
        END;
        isMOVE:=FALSE;
        isDIRECTION:=FALSE;
        isDARK:=FALSE;
        isBRIGHT:=FALSE;
        isPART:=FALSE;
        isCOLOR:=FALSE;
        col.r:=255;
        col.g:=255;
        col.b:=255;
        cc.x:=0;
        cc.y:=1000;
        cc.z:=0;
        ll.x:=0;
        ll.y:=-10;
        ll.z:=0;
        ff:=1;
        darkIndex:=10;
        brightIndex:=10;
        REPEAT
            IF Test_Tripple(kwMOVE,cc.x,cc.y,cc.z,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                IF isMOVE THEN
                BEGIN
                    BuildRCalready(rc,kwMOVE);
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                isMOVE:=TRUE
            END
            ELSE IF Test_Tripple(kwDIRECTION,ll.x,ll.y,ll.z,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                IF isDIRECTION THEN
                BEGIN
                    BuildRCalready(rc,kwDIRECTION);
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                isDIRECTION:=TRUE
            END
            ELSE IF Test_Single(kwPART,ff,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                IF isPART THEN
                BEGIN
                    BuildRCalready(rc,kwPART);
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                IF ff<=0 THEN
                BEGIN
                    BuildRCoutofrange(rc);
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                isPART:=TRUE
            END
            ELSE IF Test_Single(kwDARK,darkIndex,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                IF isDARK THEN
                BEGIN
                    BuildRCalready(rc,kwDARK);
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                IF darkIndex<0 THEN
                BEGIN
                    BuildRCoutofrange(rc);
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                isDARK:=TRUE
            END
            ELSE IF Test_Single(kwBRIGHT,brightIndex,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                IF isBRIGHT THEN
                BEGIN
                    BuildRCalready(rc,kwBRIGHT);
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                IF brightIndex<0 THEN
                BEGIN
                    BuildRCoutofrange(rc);
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                isBRIGHT:=TRUE
            END
            ELSE IF Test_Color(col,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                IF isCOLOR THEN
                BEGIN
                    BuildRCalready(rc,kwCOLOR);
                    Parse_LIGHT_SPOT:=FALSE;
                    Exit
                END;
                isCOLOR:=TRUE
            END
            ELSE BEGIN
                Parse_LIGHT_SPOT:=FALSE;
                Exit
            END;
            IF Test_Komma THEN
                finish:=FALSE
            ELSE IF Test_ClBr THEN
                finish:=TRUE
            ELSE BEGIN
                BuildRCexpected2(rc,cKomma,cBrCl);
                Parse_LIGHT_SPOT:=FALSE;
                Exit
            END
        UNTIL finish;
        IF NOT Parse_Semikolon THEN
        BEGIN
            BuildRCexpected(rc,cSemikolon); 
            Parse_LIGHT_SPOT:=FALSE;
            Exit
        END;
        SetLightSpot(cc,ll,brightIndex,darkIndex,ff,col);
        Parse_LIGHT_SPOT:=TRUE
    END;

    FUNCTION Parse_LIGHT_DISK:BOOLEAN;
    VAR cc:Vector3;
        ta,tb,tc:RealType;
        darkIndex:RealType;
        r:RealType;
        ff:RealType;
        col:RGBColor;
        isMOVE:BOOLEAN;
        isTURN:BOOLEAN;
        isDARK:BOOLEAN;
        isR:BOOLEAN;
        isPART:BOOLEAN;
        isCOLOR:BOOLEAN;
        finish:BOOLEAN;
        err:BOOLEAN;
    BEGIN
        IF NOT Parse_OpBr THEN
        BEGIN
            Parse_LIGHT_DISK:=FALSE;
            Exit
        END;
        isMOVE:=FALSE;
        isTURN:=FALSE;
        isDARK:=FALSE;
        isR:=FALSE;
        isPART:=FALSE;
        isCOLOR:=FALSE;
        col.r:=255;
        col.g:=255;
        col.b:=255;
        cc.x:=0;
        cc.y:=1000;
        cc.z:=0;
        ta:=0;
        tb:=0;
        tc:=0;
        ff:=1;
        darkIndex:=10;
        r:=100;
        REPEAT
            IF Test_Tripple(kwMOVE,cc.x,cc.y,cc.z,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                IF isMOVE THEN
                BEGIN
                    BuildRCalready(rc,kwMOVE);
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                isMOVE:=TRUE
            END
            ELSE IF Test_Tripple(kwTURN,ta,tb,tc,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                IF isTURN THEN
                BEGIN
                    BuildRCalready(rc,kwTURN);
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                isTURN:=TRUE
            END
            ELSE IF Test_Single(kwPART,ff,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                IF isPART THEN
                BEGIN
                    BuildRCalready(rc,kwPART);
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                IF ff<=0 THEN
                BEGIN
                    BuildRCoutofrange(rc);
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                isPART:=TRUE
            END
            ELSE IF Test_Single(kwRADIUS,r,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                IF isR THEN
                BEGIN
                    BuildRCalready(rc,kwRADIUS);
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                IF r<=0.1 THEN
                BEGIN
                    BuildRCoutofrange(rc);
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                isR:=TRUE
            END
            ELSE IF Test_Single(kwDARK,darkIndex,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                IF isDARK THEN
                BEGIN
                    BuildRCalready(rc,kwDARK);
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                IF darkIndex<0 THEN
                BEGIN
                    BuildRCoutofrange(rc);
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                isDARK:=TRUE
            END
            ELSE IF Test_Color(col,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                IF isCOLOR THEN
                BEGIN
                    BuildRCalready(rc,kwCOLOR);
                    Parse_LIGHT_DISK:=FALSE;
                    Exit
                END;
                isCOLOR:=TRUE
            END
            ELSE BEGIN
                Parse_LIGHT_DISK:=FALSE;
                Exit
            END;
            IF Test_Komma THEN
                finish:=FALSE
            ELSE IF Test_ClBr THEN
                finish:=TRUE
            ELSE BEGIN
                BuildRCexpected2(rc,cKomma,cBrCl);
                Parse_LIGHT_DISK:=FALSE;
                Exit
            END
        UNTIL finish;
        IF NOT Parse_Semikolon THEN
        BEGIN
            BuildRCexpected(rc,cSemikolon);
            Parse_LIGHT_DISK:=FALSE;
            Exit
        END;
        SetLightDisk(cc,ta,tb,tc,r,darkIndex,ff,col);
        Parse_LIGHT_DISK:=TRUE
    END;




    FUNCTION Parse_LIGHTS:BOOLEAN;
    VAR finish:BOOLEAN;
    BEGIN
        IF NOT Parse_KEYWORD(kwLIGHTS) THEN
        BEGIN
            Parse_LIGHTS:=FALSE;
            Exit
        END;
        finish:=FALSE;
        REPEAT
            IF LightCnt>=maxLight THEN
            BEGIN
                BuildRCtoomany(rc,kwLIGHTS);
                Parse_LIGHTS:=FALSE;
                Exit
            END;

            IF Test_KEYWORD(kwCENTRAL) THEN
            BEGIN
                IF NOT Parse_LIGHT_CENTRAL THEN
                BEGIN
                    Parse_LIGHTS:=FALSE;
                    Exit
                END;
            END
            ELSE IF Test_KEYWORD(kwNORMAL) THEN
            BEGIN
                IF NOT Parse_LIGHT_NORMAL THEN
                BEGIN
                    Parse_LIGHTS:=FALSE;
                    Exit
                END;
            END
            ELSE IF Test_KEYWORD(kwSTICK) THEN
            BEGIN
                IF NOT Parse_LIGHT_STICK THEN
                BEGIN
                    Parse_LIGHTS:=FALSE;
                    Exit
                END;
            END
            ELSE IF Test_KEYWORD(kwDISK) THEN
            BEGIN
                IF NOT Parse_LIGHT_DISK THEN
                BEGIN
                    Parse_LIGHTS:=FALSE;
                    Exit
                END;
            END
            ELSE IF Test_KEYWORD(kwSPOT) THEN
            BEGIN
                IF NOT Parse_LIGHT_SPOT THEN
                BEGIN
                    Parse_LIGHTS:=FALSE;
                    Exit
                END;
            END
            ELSE IF Test_KEYWORD(kwEND) THEN
                finish:=TRUE
            ELSE BEGIN
                Parse_LIGHTS:=FALSE;
                Exit
            END;
        UNTIL finish;
        Parse_LIGHTS:=TRUE
    END;





    FUNCTION Parse_PICTURES:BOOLEAN;
    VAR name:STRING;
        res:BYTE;
        found:BOOLEAN;
        i:WORD;
        err:BOOLEAN;
        fileName:STRING;
    BEGIN
        cntPICTURES:=0;
        IF NOT Parse_KEYWORD(kwPICTURES) THEN
        BEGIN
            Parse_PICTURES:=FALSE;
            Exit
        END;

        res:=Parse_NAME(name);
        WHILE res=1 DO
        BEGIN
            found:=FALSE;
            FOR i:=1 TO cntPICTURES DO
                IF name=arPICTURES[i].namePICTURE THEN
                    found:=TRUE;
            IF found THEN
            BEGIN
                BuildRCtwice(rc,name,kwPICTURE);
                Parse_PICTURES:=FALSE;
                EXIT
            END;

            INC(cntPICTURES);
            IF cntPICTURES>maxPICTURES THEN
            BEGIN
                BuildRCtoomany(rc,kwPICTURES);
                Parse_PICTURES:=FALSE;
                Exit
            END;

            arPICTURES[cntPICTURES].namePICTURE:=name;
            arPICTURES[cntPICTURES].used:=FALSE;

            IF NOT Parse_Eq THEN
            BEGIN
                Parse_PICTURES:=FALSE;
                Exit
            END;

            IF Test_SingleString(kwFILE,fileNAME,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_PICTURES:=FALSE;
                    Exit
                END
            END
            ELSE BEGIN
                Parse_PICTURES:=FALSE;
                Exit
            END;

            IOR:=LoadColMat(arPICTURES[cntPICTURES].pict,fileName);
            IF IOR>0 THEN
            BEGIN
                BuildRCfileError(rc,fileName,IOR);
                Parse_PICTURES:=FALSE;
                Exit
            END;


            IF NOT Parse_Semikolon THEN
            BEGIN
                Parse_PICTURES:=FALSE;
                Exit
            END;

            res:=Parse_NAME(name);
        END;

        IF res=2 THEN
        BEGIN
            IF Parse_KEYWORD(kwEND) THEN
            BEGIN
                Parse_PICTURES:=TRUE;
                Exit
            END
            ELSE BEGIN
                Parse_PICTURES:=FALSE;
                Exit
            END
        END
        ELSE BEGIN
            Parse_PICTURES:=FALSE;
            Exit
        END
    END;





    FUNCTION FindVTexture(name:STRING;VAR val:PVectorTexture):BOOLEAN;
    VAR found:BOOLEAN;
        i:WORD;
    BEGIN
        FOR i:=1 TO cntVT DO
            IF name=vTextures[i].vName THEN
            BEGIN
                val:=@vTextures[i].t;
                vTextures[i].used:=TRUE;


                FindVTexture:=TRUE;
                Exit
            END;
        BuildRCnotfound(rc,name,kwVECTORTEXTURES);
        FindVTexture:=FALSE

    END;


    FUNCTION Test_Texture(VAR tx:PVectorTexture;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
        err:BOOLEAN;
    BEGIN
        IF NOT Test_SingleName(kwTEXTURE,name,err) THEN
        BEGIN
            error:=FALSE;
            Test_Texture:=FALSE;
            Exit
        END;
        error:=TRUE;
        IF err THEN
        BEGIN
            Test_Texture:=TRUE;
            Exit
        END;
        IF NOT FindVTexture(name,tx) THEN
        BEGIN
            Test_Texture:=TRUE;
            Exit
        END;
        error:=FALSE;
        Test_Texture:=TRUE
    END;

    FUNCTION Test_Texture1(VAR tx:PVectorTexture;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
        err:BOOLEAN;
    BEGIN
        IF NOT Test_SingleName(kwTEXTURE1,name,err) THEN
        BEGIN
            error:=FALSE;
            Test_Texture1:=FALSE;
            Exit
        END;
        error:=TRUE;
        IF err THEN
        BEGIN
            Test_Texture1:=TRUE;
            Exit
        END;
        IF NOT FindVTexture(name,tx) THEN
        BEGIN
            Test_Texture1:=TRUE;
            Exit
        END;
        error:=FALSE;
        Test_Texture1:=TRUE
    END;


    FUNCTION Test_Texture2(VAR tx:PVectorTexture;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
        err:BOOLEAN;
    BEGIN
        IF NOT Test_SingleName(kwTEXTURE2,name,err) THEN
        BEGIN
            error:=FALSE;
            Test_Texture2:=FALSE;
            Exit
        END;
        error:=TRUE;
        IF err THEN
        BEGIN
            Test_Texture2:=TRUE;
            Exit
        END;
        IF NOT FindVTexture(name,tx) THEN
        BEGIN
            Test_Texture2:=TRUE;
            Exit
        END;
        error:=FALSE;
        Test_Texture2:=TRUE
    END;

    FUNCTION Test_VTType(VAR onlyCol:BOOLEAN;VAR extType:BYTE;VAR fkt:VectorTextureFkt;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
    BEGIN
        IF NOT Test_KEYWORD(kwTYPE) THEN
        BEGIN
            error:=FALSE;
            Test_VTType:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_VTType:=TRUE;
            EXIT
        END;
        IF NOT (Parse_Name(name)=1) THEN
        BEGIN
            Test_VTType:=TRUE;
            EXIT
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_VTType:=TRUE;
            EXIT
        END;
        onlyCol:=FALSE;
        extType:=0;
        IF name=kwUNIQUE THEN
            onlyCol:=TRUE
        ELSE IF name=kwCOLORPATTERN THEN
            extType:=1
        ELSE IF name=kwBUILD THEN
            extType:=2
        ELSE IF name=kwBUILDMAX THEN
            extType:=3
        ELSE IF name=kwBUILDMIN THEN
            extType:=4
        ELSE IF name=kwMARBLE THEN
            fkt:=VTMarble
        ELSE IF name=kwSTARS THEN
            fkt:=VTStars
        ELSE IF name=kwPLATINE THEN
            fkt:=VTPlatine
        ELSE IF name=kwLINES THEN
            fkt:=VTLines
        ELSE IF name=kwLINES2 THEN
            fkt:=VTLines2
        ELSE IF name=kwHEXAGON THEN
            fkt:=VTHexagon
        ELSE IF name=kwHEXAGONN THEN
            fkt:=VTHexagonN
        ELSE IF name=kwTRIANGLE THEN
            fkt:=VTTriangle
        ELSE IF name=kwTRIANGLEN THEN
            fkt:=VTTriangleN
        ELSE IF name=kwSQUARE THEN
            fkt:=VTSquare
        ELSE IF name=kwSTRUCT THEN
            fkt:=VTStruct
        ELSE IF name=kwSQUAREN THEN
            fkt:=VTSquareN
        ELSE IF name=kwWATER THEN
            fkt:=VTWater
        ELSE IF name=kwMARBLEN THEN
            fkt:=VTMarbleN
        ELSE IF name=kwMARBLENN THEN
            fkt:=VTMarbleNN
        ELSE IF name=kwCHESS THEN
            fkt:=VTChess
        ELSE IF name=kwPLANETOID THEN
            fkt:=VTPlanetoid
        ELSE IF name=kwPLANETOIDN THEN
            fkt:=VTPlanetoidN
        ELSE IF name=kwWOOD THEN
            fkt:=VTWood
        ELSE IF name=kwFILM THEN
            fkt:=VTFilm
        ELSE IF name=kwFILMN THEN
            fkt:=VTFilmN
        ELSE BEGIN
            BuildRCunknown(rc,name,kwVECTORTEXTURES);
            Test_VTType:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_VTType:=TRUE
    END;

    FUNCTION Test_STType(VAR onlyF:BOOLEAN;VAR extType:BYTE;VAR fkt:ScalarTextureFkt;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
    BEGIN
        IF NOT Test_KEYWORD(kwTYPE) THEN
        BEGIN
            error:=FALSE;
            Test_STType:=FALSE;
            EXIT
        END;
        error:=TRUE;
        extType:=0;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_STType:=TRUE;
            EXIT
        END;
        IF NOT (Parse_Name(name)=1) THEN
        BEGIN
            Test_STType:=TRUE;
            EXIT
        END;
        IF NOT Parse_ClBr THEN
        BEGIN
            Test_STType:=TRUE;
            EXIT
        END;
        onlyF:=FALSE;
        extType:=0;
        IF name=kwFACTOR THEN
            onlyF:=TRUE
        ELSE IF name=kwPATTERN THEN
            extType:=1
        ELSE IF name=kwMARBLE THEN
            fkt:=STMarble
        ELSE IF name=kwPLANETOID THEN
            fkt:=STPlanetoid
        ELSE IF name=kwPLATINE THEN
            fkt:=STPlatine
        ELSE IF name=kwLINES THEN
            fkt:=STLines
        ELSE IF name=kwBLUR THEN
            fkt:=STBlur
        ELSE IF name=kwBLURPLANETOID THEN
            fkt:=STBlurPlanetoid
        ELSE BEGIN
            BuildRCunknown(rc,name,kwSCALARTEXTURES);
            Test_STType:=TRUE;
            EXIT
        END;
        error:=FALSE;
        Test_STType:=TRUE
    END;



    FUNCTION Test_COLORLIST(VAR colors:ColorArray;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
        finish:BOOLEAN;
        found:BOOLEAN;
        cntC:WORD;
        i:WORD;
    BEGIN
        IF NOT Test_KEYWORD(kwCOLORLIST) THEN
        BEGIN
            error:=FALSE;
            Test_COLORLIST:=FALSE;
            EXIT
        END;
        error:=TRUE;
        IF NOT Parse_OpBr THEN
        BEGIN
            Test_COLORLIST:=TRUE;
            EXIT
        END;
        cntC:=1;

        REPEAT

            IF NOT (Parse_NAME(name)=1) THEN
            BEGIN
                Test_COLORLIST:=TRUE;
                EXIT
            END;
            found:=FALSE;
            FOR i:=1 TO cntCOLORS DO
                IF name=arCOLORS[i].nameCOLOR THEN
                BEGIN
                   copyRGBcol(arCOLORS[i].col,colors[cntC]);
                   INC(cntC);
                   found:=TRUE
                END;

            IF NOT found THEN
            BEGIN
                BuildRCunknown(rc,name,kwCOLOR);
                Test_COLORLIST:=TRUE;
                EXIT
            END;

            IF Test_Komma THEN
                finish:=FALSE
            ELSE IF Test_ClBr THEN
                finish:=TRUE
            ELSE BEGIN
                BuildRCexpected2(rc,cKomma,cBrCl);
                Test_COLORLIST:=TRUE;
                Exit
            END
        UNTIL finish;

        error:=FALSE;
        Test_COLORLIST:=TRUE
    END;


    FUNCTION Parse_VECTORTEXTURES:BOOLEAN;
    VAR res:BYTE;
        name:STRING;
        found:BOOLEAN;
        finish:BOOLEAN;
        isTYPE:BOOLEAN;
        isTRANSLATION:BOOLEAN;
        isCOLORLIST:BOOLEAN;
        isFILE:BOOLEAN;
        isTEXTURE1:BOOLEAN;
        isTEXTURE2:BOOLEAN;
        isPART:BOOLEAN;
        isPICTURE:BOOLEAN;
        i:WORD;
        tx1,tx2:PVectorTexture;
        colors:ColorArray;
        onlyCol:BOOLEAN;
        extType:BYTE;
        fkt:VectorTextureFkt;
        part1:RealType;
        mx,my,mz,ta,tb,tc,sx,sy,sz:RealType;
        fileName:STRING;
        dummyM:Matrix3;
        err:BOOLEAN;
        IOR:INTEGER;
        pict:ColMat;
    BEGIN
        IF NOT Parse_KEYWORD(kwVECTORTEXTURES) THEN
        BEGIN
            Parse_VECTORTEXTURES:=FALSE;
            Exit
        END;
        cntVT:=0;
        res:=Parse_NAME(name);
        WHILE res=1 DO
        BEGIN
            IF NOT Parse_EqBr THEN
            BEGIN
                Parse_VECTORTEXTURES:=FALSE;
                Exit
            END;

            found:=FALSE;
            FOR i:=1 TO cntVT DO
                IF name=vTextures[i].vName THEN
                    found:=TRUE;
            IF found THEN
            BEGIN
                BuildRCtwice(rc,name,kwVECTORTEXTURES);
                Parse_VECTORTEXTURES:=FALSE;
                EXIT
            END;

            INC(cntVT);
            IF cntVT>maxVTexture THEN
            BEGIN
                BuildRCtoomany(rc,kwVECTORTEXTURES);
                Parse_VECTORTEXTURES:=FALSE;
                Exit
            END;

            vTextures[cntVT].vName:=name;
            vTextures[cntVT].used:=FALSE;

            isTYPE:=FALSE;
            isTRANSLATION:=FALSE;
            isCOLORLIST:=FALSE;
            isFILE:=FALSE;
            isTEXTURE1:=FALSE;
            isTEXTURE2:=FALSE;
            isPART:=FALSE;
            isPICTURE:=FALSE;

            pict:=NIL;
            onlyCol:=TRUE;
            extType:=0;
            tx1:=NIL;
            tx2:=NIL;
            mx:=0;
            my:=0;
            mz:=0;
            ta:=0;
            tb:=0;
            tc:=0;
            sx:=1;
            sy:=1;
            sz:=1;
            part1:=0.5;
            FOR i:=1 TO maxColor DO
            BEGIN
                colors[i].r:=255;
                colors[i].g:=255;
                colors[i].b:=255
            END;

            REPEAT
                IF Test_VTType(onlyCol,extType,fkt,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isTYPE THEN
                    BEGIN
                        BuildRCalready(rc,kwTYPE);
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    isTYPE:=TRUE
                END
                ELSE IF Test_Single(kwPART,part1,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isPART THEN
                    BEGIN
                        BuildRCalready(rc,kwPART);
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    isPART:=TRUE
                END

                ELSE IF Test_SingleString(kwFILE,fileNAME,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isFILE THEN
                    BEGIN
                        BuildRCalready(rc,kwNAME);
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    isFILE:=TRUE
                END
                ELSE IF Test_Picture(pict,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isPICTURE THEN
                    BEGIN
                        BuildRCalready(rc,kwPICTURE);
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    isPICTURE:=TRUE
                END
                ELSE IF Test_Texture1(tx1,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isTEXTURE1 THEN
                    BEGIN
                        BuildRCalready(rc,kwTEXTURE1);
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    isTEXTURE1:=TRUE
                END
                ELSE IF Test_Texture2(tx2,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isTEXTURE2 THEN
                    BEGIN
                        BuildRCalready(rc,kwTEXTURE2);
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    isTEXTURE2:=TRUE
                END
                ELSE IF Test_TRANSLATION(mx,my,mz,ta,tb,tc,sx,sy,sz,TRUE,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isTRANSLATION THEN
                    BEGIN
                        BuildRCalready(rc,kwTRANSLATION);
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    isTRANSLATION:=TRUE
                END
                ELSE IF Test_COLORLIST(colors,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isCOLORLIST THEN
                    BEGIN
                        BuildRCalready(rc,kwCOLORLIST);
                        Parse_VECTORTEXTURES:=FALSE;
                        Exit
                    END;
                    isCOLORLIST:=TRUE
                END
                ELSE BEGIN
                    Parse_VECTORTEXTURES:=FALSE;
                    Exit
                END;
                IF Test_Komma THEN
                    finish:=FALSE
                ELSE IF Test_ClBr THEN
                    finish:=TRUE
                ELSE BEGIN
                    BuildRCexpected2(rc,cKomma,cBrCl);
                    Parse_VECTORTEXTURES:=FALSE;
                    Exit
                END
            UNTIL finish;
            IF NOT Parse_Semikolon THEN
            BEGIN
                BuildRCexpected(rc,cSemikolon);
                Parse_VECTORTEXTURES:=FALSE;
                Exit
            END;

            IF (extType=1) AND NOT (isFILE OR isPICTURE) THEN
            BEGIN
                BuildRCmissing(rc,kwFILE);
                Parse_VECTORTEXTURES:=FALSE;
                Exit
            END;

            IF ((extType=2) OR (extType=3) OR (extType=4)) AND NOT isTEXTURE1 THEN
            BEGIN
                BuildRCmissing(rc,kwTEXTURE1);
                Parse_VECTORTEXTURES:=FALSE;
                Exit
            END;
            IF ((extType=2) OR (extType=3) OR (extType=4)) AND NOT isTEXTURE2 THEN
            BEGIN
                BuildRCmissing(rc,kwTEXTURE2);
                Parse_VECTORTEXTURES:=FALSE;
                Exit
            END;

            IF isTEXTURE1 AND (extType<>2) AND (extType<>3) AND (extType<>4) THEN
            BEGIN
                BuildRC(rc,err117);
                Parse_VECTORTEXTURES:=FALSE;
                Exit
            END;
            IF isTEXTURE2 AND (extType<>2) AND (extType<>3) AND (extType<>4) THEN
            BEGIN
                BuildRC(rc,err117);
                Parse_VECTORTEXTURES:=FALSE;
                Exit
            END;
            IF isPART AND (extType<>2) AND (extType<>3) AND (extType<>4) THEN
            BEGIN
                BuildRC(rc,err118);
                Parse_VECTORTEXTURES:=FALSE;
                Exit
            END;
            IF isFILE AND isPICTURE THEN
            BEGIN
                BuildRC(rc,err119);
                Parse_VECTORTEXTURES:=FALSE;
                Exit
            END;

            WITH vTextures[cntVT] DO
            BEGIN
                t.extension:=NIL;
                t.extension2:=NIL;
                IF (extType=1) THEN
                BEGIN
                    IF isFILE THEN
                    BEGIN
                        IOR:=LoadColMat(ColMat(t.extension),fileName);
                        IF IOR>0 THEN
                        BEGIN
                            BuildRCfileError(rc,fileName,IOR);
                            Parse_VECTORTEXTURES:=FALSE;
                            Exit
                        END
                    END
                    ELSE BEGIN
                        t.extension:=pict
                    END
                END;
                IF (extType=2) OR (extType=3) OR (extType=4) THEN
                BEGIN
                    t.extension:=tx1;
                    t.extension2:=tx2
                END;

                t.part1:=part1;
                t.part2:=1-part1;

                t.colors:=colors;
                t.onlyCol:=onlyCol;
                t.extType:=extType;
                t.fkt:=fkt;
                t.c.x:=mx;
                t.c.y:=my;
                t.c.z:=mz;
                Translation(t.m,dummyM,sx,sy,sz,ta,tb,tc)
            END;

            res:=Parse_NAME(name);
        END;

        IF res=2 THEN
        BEGIN
            IF Parse_KEYWORD(kwEND) THEN
            BEGIN
                Parse_VECTORTEXTURES:=TRUE;
                Exit
            END
            ELSE BEGIN
                Parse_VECTORTEXTURES:=FALSE;
                Exit
            END
        END
        ELSE BEGIN
            Parse_VECTORTEXTURES:=FALSE;
            Exit
        END
    END;

    FUNCTION Parse_SCALARTEXTURES:BOOLEAN;
    VAR res:BYTE;
        name:STRING;
        found:BOOLEAN;
        finish:BOOLEAN;
        isTYPE:BOOLEAN;
        isTRANSLATION:BOOLEAN;
        isFACTOR:BOOLEAN;
        isFILE:BOOLEAN;
        i:WORD;
        onlyF:BOOLEAN;
        extType:BYTE;
        f:RealType;
        fkt:ScalarTextureFkt;
        mx,my,mz,ta,tb,tc,sx,sy,sz:RealType;
        fileName:STRING;
        dummyM:Matrix3;
        err:BOOLEAN;
    BEGIN
        IF NOT Parse_KEYWORD(kwSCALARTEXTURES) THEN
        BEGIN
            Parse_SCALARTEXTURES:=FALSE;
            Exit
        END;
        cntST:=0;
        res:=Parse_NAME(name);
        WHILE res=1 DO
        BEGIN
            IF NOT Parse_EqBr THEN
            BEGIN
                Parse_SCALARTEXTURES:=FALSE;
                Exit
            END;

            found:=FALSE;
            FOR i:=1 TO cntST DO
                IF name=sTextures[i].sName THEN
                    found:=TRUE;
            IF found THEN
            BEGIN
                BuildRCtwice(rc,name,kwSCALARTEXTURES);
                Parse_SCALARTEXTURES:=FALSE;
                EXIT
            END;

            INC(cntST);
            IF cntST>maxSTexture THEN
            BEGIN
                BuildRCtoomany(rc,kwSCALARTEXTURES);
                Parse_SCALARTEXTURES:=FALSE;
                Exit
            END;

            sTextures[cntST].sName:=name;
            sTextures[cntST].used:=FALSE;

            isTYPE:=FALSE;
            isTRANSLATION:=FALSE;
            isFACTOR:=FALSE;
            isFILE:=FALSE;

            onlyF:=TRUE;
            extType:=0;
            mx:=0;
            my:=0;
            mz:=0;
            ta:=0;
            tb:=0;
            tc:=0;
            sx:=1;
            sy:=1;
            sz:=1;
            f:=1;

            REPEAT
                IF Test_STType(onlyF,extType,fkt,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_SCALARTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isTYPE THEN
                    BEGIN
                        BuildRCalready(rc,kwTYPE);
                        Parse_SCALARTEXTURES:=FALSE;
                        Exit
                    END;
                    isTYPE:=TRUE
                END
                ELSE IF Test_TRANSLATION(mx,my,mz,ta,tb,tc,sx,sy,sz,TRUE,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_SCALARTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isTRANSLATION THEN
                    BEGIN
                        BuildRCalready(rc,kwTRANSLATION);
                        Parse_SCALARTEXTURES:=FALSE;
                        Exit
                    END;
                    isTRANSLATION:=TRUE
                END
                ELSE IF Test_SingleString(kwFILE,fileNAME,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_SCALARTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isFILE THEN
                    BEGIN
                        BuildRCalready(rc,kwNAME);
                        Parse_SCALARTEXTURES:=FALSE;
                        Exit
                    END;
                    isFILE:=TRUE
                END
                ELSE IF Test_SINGLE(kwFACTOR,f,err) THEN
                BEGIN
                    IF err THEN
                    BEGIN
                        Parse_SCALARTEXTURES:=FALSE;
                        Exit
                    END;
                    IF isFACTOR THEN
                    BEGIN
                        BuildRCalready(rc,kwFACTOR);
                        Parse_SCALARTEXTURES:=FALSE;
                        Exit
                    END;
                    isFACTOR:=TRUE
                END
                ELSE BEGIN
                    Parse_SCALARTEXTURES:=FALSE;
                    Exit
                END;
                IF Test_Komma THEN
                    finish:=FALSE
                ELSE IF Test_ClBr THEN
                    finish:=TRUE
                ELSE BEGIN
                    BuildRCexpected2(rc,cKomma,cBrCl);
                    Parse_SCALARTEXTURES:=FALSE;
                    Exit
                END
            UNTIL finish;


            IF (extType>0) AND NOT isFILE THEN
            BEGIN
                BuildRCmissing(rc,kwFILE);
                Parse_SCALARTEXTURES:=FALSE;
                Exit
            END;

            IF isFACTOR AND NOT onlyF THEN
            BEGIN
                BuildRC(rc,err100);
                Parse_SCALARTEXTURES:=FALSE;
                Exit
            END;
            IF NOT isFACTOR AND onlyF THEN
            BEGIN
                BuildRC(rc,err101);
                Parse_SCALARTEXTURES:=FALSE;
                Exit
            END;
            IF NOT Parse_Semikolon THEN
            BEGIN
                BuildRCexpected(rc,cSemikolon);
                Parse_SCALARTEXTURES:=FALSE;
                Exit
            END;

            WITH sTextures[cntST] DO
            BEGIN
                t.extension:=NIL;
                IF extType=1 THEN
                BEGIN
                    IOR:=LoadColMat(ColMat(t.extension),fileName);
                    IF IOR>0 THEN
                    BEGIN
                        BuildRCfileError(rc,fileName,IOR);
                        Parse_SCALARTEXTURES:=FALSE;
                        Exit
                    END
                END;

                t.onlyF:=onlyF;
                t.extType:=extType;
                t.fkt:=fkt;
                t.f:=f;
                t.c.x:=mx;
                t.c.y:=my;
                t.c.z:=mz;
                Translation(t.m,dummyM,sx,sy,sz,ta,tb,tc)
            END;

            res:=Parse_NAME(name);
        END;

        IF res=2 THEN
        BEGIN
            IF Parse_KEYWORD(kwEND) THEN
            BEGIN
                Parse_SCALARTEXTURES:=TRUE;
                Exit
            END
            ELSE BEGIN
                Parse_SCALARTEXTURES:=FALSE;
                Exit
            END
        END
        ELSE BEGIN
            Parse_SCALARTEXTURES:=FALSE;
            Exit
        END
    END;


    FUNCTION FindSTexture(name:STRING;VAR val:PScalarTexture):BOOLEAN;
    VAR found:BOOLEAN;
        i:WORD;
    BEGIN
        FOR i:=1 TO cntST DO
            IF name=sTextures[i].sName THEN
            BEGIN
                val:=@sTextures[i].t;
                sTextures[i].used:=TRUE;


                FindSTexture:=TRUE;
                Exit
            END;
        BuildRCnotfound(rc,name,kwSCALARTEXTURES);
        FindSTexture:=FALSE

    END;



    FUNCTION Test_Reflection(VAR isRfl:BOOLEAN;VAR reflVal:PScalarTexture;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
        err:BOOLEAN;
    BEGIN
        IF NOT Test_SingleName(kwREFLECTION,name,err) THEN
        BEGIN
            error:=FALSE;
            Test_Reflection:=FALSE;
            Exit
        END;
        error:=TRUE;
        IF err THEN
        BEGIN
            Test_Reflection:=TRUE;
            Exit
        END;
        IF NOT FindSTexture(name,reflVal) THEN
        BEGIN
            Test_Reflection:=TRUE;
            Exit
        END;
        error:=FALSE;
        isRfl:=TRUE;
        Test_Reflection:=TRUE
    END;


    FUNCTION Test_Refraction(VAR isRfr:BOOLEAN;VAR refrVal:PScalarTexture;VAR refrInd:RealType;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
        err:BOOLEAN;
    BEGIN
        IF NOT Test_DoubleNameReal(kwREFRACTION,name,refrInd,err) THEN
        BEGIN
            error:=FALSE;
            Test_Refraction:=FALSE;
            Exit
        END;
        error:=TRUE;
        IF err THEN
        BEGIN
            Test_Refraction:=TRUE;
            Exit
        END;
        IF NOT FindSTexture(name,refrVal) THEN
        BEGIN
            Test_Refraction:=TRUE;
            Exit
        END;
        error:=FALSE;
        isRfr:=TRUE;
        Test_Refraction:=TRUE
    END;


    FUNCTION Test_Shaddow(VAR isSha:BOOLEAN;VAR sha,ssh:RealType;VAR error:BOOLEAN):BOOLEAN;
    VAR err:BOOLEAN;
    BEGIN
        IF NOT Test_DoubleRealReal(kwSHADDOWED,sha,ssh,err) THEN
        BEGIN
            error:=FALSE;
            Test_Shaddow:=FALSE;
            Exit
        END;
        error:=TRUE;
        IF err THEN
        BEGIN
            Test_Shaddow:=TRUE;
            Exit
        END;
        error:=FALSE;
        isSha:=TRUE;
        Test_Shaddow:=TRUE
    END;

    FUNCTION Test_Bright(VAR isBr:BOOLEAN;VAR br,brInd:RealType;VAR error:BOOLEAN):BOOLEAN;
    VAR err:BOOLEAN;
    BEGIN
        IF NOT Test_DoubleRealReal(kwBRIGHT,br,brInd,err) THEN
        BEGIN
            error:=FALSE;
            Test_Bright:=FALSE;
            Exit
        END;
        error:=TRUE;
        IF err THEN
        BEGIN
            Test_Bright:=TRUE;
            Exit
        END;
        error:=FALSE;
        isBr:=TRUE;
        Test_Bright:=TRUE
    END;


    FUNCTION Test_Transparent(VAR isTr:BOOLEAN;VAR trVal:PScalarTexture;VAR error:BOOLEAN):BOOLEAN;
    VAR name:STRING;
        err:BOOLEAN;
    BEGIN
        IF NOT Test_SingleName(kwTRANSPARENT,name,err) THEN
        BEGIN
            error:=FALSE;
            Test_Transparent:=FALSE;
            Exit
        END;
        error:=TRUE;
        IF err THEN
        BEGIN
            Test_Transparent:=TRUE;
            Exit
        END;
        IF NOT FindSTexture(name,trVal) THEN
        BEGIN
            Test_Transparent:=TRUE;
            Exit
        END;
        error:=FALSE;
        isTr:=TRUE;
        Test_Transparent:=TRUE
    END;




    FUNCTION Test_FigVARS(VAR ff1,ff2,ff3,ff4,ff5,ff6,ffr:RealType;VAR error:BOOLEAN):BOOLEAN;
    VAR err:BOOLEAN;
    BEGIN
        IF NOT Test_7Real(kwVARS,ff1,ff2,ff3,ff4,ff5,ff6,ffr,err) THEN
        BEGIN
            error:=FALSE;
            Test_FigVARS:=FALSE;
            Exit
        END;
        error:=TRUE;
        IF err THEN
        BEGIN
            Test_FigVARS:=TRUE;
            Exit
        END;
        error:=FALSE;
        Test_FigVARS:=TRUE

    END;


    FUNCTION Test_PARTFIG(VAR kind:FigKind;VAR fg:POINTER;VAR error:BOOLEAN):BOOLEAN;
    VAR pBuild:PBuildFigur;
        pSolid:PSolidObject;
        smoothFig:BOOLEAN;
        isTRANSLATION:BOOLEAN;
        isSMOOTH:BOOLEAN;
        isNAME:BOOLEAN;
        isTYPE:BOOLEAN;
        isRADIUS:BOOLEAN;
        isREFL:BOOLEAN;
        isREFR:BOOLEAN;
        isSHAD:BOOLEAN;
        isBRI:BOOLEAN;
        isTRANS:BOOLEAN;
        isSHADDOWES:BOOLEAN;
        isTEXTURE:BOOLEAN;
        isVARS:BOOLEAN;
        isBOX:BOOLEAN;
        radiusExpected:BOOLEAN;

        mx,my,mz,ta,tb,tc,sx,sy,sz:RealType;
        rSm:RealType;
        newKind:FigKind;
        newFg:POINTER;
        finish:BOOLEAN;
        nm:STRING;
        bxf,bxt,byf,byt,bzf,bzt:RealType;

        br,brInd,refrInd,sha,ssh:RealType;
        reflVal:PScalarTexture;
        refrVal:PScalarTexture;
        trVal:PScalarTexture;
        ff1,ff2,ff3,ff4,ff5,ff6,ffr:RealType;

        sm:BOOLEAN;
        isRfl:BOOLEAN;
        isRfr:BOOLEAN;
        isSha:BOOLEAN;
        isBr:BOOLEAN;
        isTr:BOOLEAN;
        shao:BOOLEAN;
        tx:PVectorTexture;
        figType:STRING;
        figR:RealType;

        name:STRING;
        i:WORD;
        err:BOOLEAN;

    BEGIN
        IF (Parse_NAME(name)=1) THEN
        BEGIN
            FOR i:=1 TO cntF DO
                IF name=Fig[i].fName THEN
                BEGIN
                    kind:=Fig[i].f.kind;
                    fg:=Fig[i].f.fig;
                    Fig[i].used:=TRUE;
                    error:=FALSE;
                    Test_PARTFIG:=TRUE;
                    Exit
                END;
            UngetStr(name)
        END;
        IF Test_KEYWORD(kwOBJ) THEN
        BEGIN
            error:=TRUE;
            IF NOT Parse_OpBr THEN
            BEGIN
                Test_PARTFIG:=TRUE;
                Exit
            END;
            kind:=Solid;
            IF MaxAvail<SizeOf(SolidObject) THEN
            BEGIN
                BuildRCmemovl(rc);
                Test_PARTFIG:=TRUE;
                Exit
            END;

            New(pSolid);

            WITH pSolid^ DO
            BEGIN

                isTRANSLATION:=FALSE;
                isSMOOTH:=FALSE;
                isNAME:=FALSE;
                isTYPE:=FALSE;
                isRADIUS:=FALSE;
                isREFL:=FALSE;
                isREFR:=FALSE;
                isSHAD:=FALSE;
                isBRI:=FALSE;
                isTRANS:=FALSE;
                isSHADDOWES:=FALSE;
                isTEXTURE:=FALSE;
                isVARS:=FALSE;

                mx:=0;
                my:=0;
                mz:=0;
                ta:=0;
                tb:=0;
                tc:=0;
                sx:=1;
                sy:=1;
                sz:=1;
                sm:=FALSE;
                nm:='?';

                isRfl:=FALSE;
                isRfr:=FALSE;
                isSha:=FALSE;
                isBr:=FALSE;
                isTr:=FALSE;
                shao:=TRUE;
                tx:=NIL;
                figR:=1000;
                radiusExpected:=FALSE;

                REPEAT
                    IF Test_TRANSLATION(mx,my,mz,ta,tb,tc,sx,sy,sz,TRUE,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isTRANSLATION THEN
                        BEGIN
                            BuildRCalready(rc,kwTRANSLATION);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isTRANSLATION:=TRUE
                    END
                    ELSE IF Test_SingleBool(kwSMOOTH,sm,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isSMOOTH THEN
                        BEGIN
                            BuildRCalready(rc,kwSMOOTH);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isSMOOTH:=TRUE
                    END
                    ELSE IF Test_SingleName(kwTYPE,figType,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isTYPE THEN
                        BEGIN
                            BuildRCalready(rc,kwTYPE);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isTYPE:=TRUE
                    END
                    ELSE IF Test_FigVARS(ff1,ff2,ff3,ff4,ff5,ff6,ffr,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isVARS THEN
                        BEGIN
                            BuildRCalready(rc,kwVARS);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isVARS:=TRUE
                    END
                    ELSE IF Test_Single(kwRADIUS,figR,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isRADIUS THEN
                        BEGIN
                            BuildRCalready(rc,kwRADIUS);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isRADIUS:=TRUE
                    END
                    ELSE IF Test_Single(kwDIAMETER,figR,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        figR:=figR/2;
                        IF isRADIUS THEN
                        BEGIN
                            BuildRCalready(rc,kwDIAMETER);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isRADIUS:=TRUE
                    END
                    ELSE IF Test_Reflection(isRfl,reflVal,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isREFL THEN
                        BEGIN
                            BuildRCalready(rc,kwREFLECTION);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isREFL:=TRUE
                    END
                    ELSE IF Test_Refraction(isRfr,refrVal,refrInd,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isREFR THEN
                        BEGIN
                            BuildRCalready(rc,kwREFRACTION);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isREFR:=TRUE
                    END
                    ELSE IF Test_Shaddow(isSha,sha,ssh,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isSHAD THEN
                        BEGIN
                            BuildRCalready(rc,kwSHADDOWED);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isSHAD:=TRUE
                    END
                    ELSE IF Test_Bright(isBr,br,brInd,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isBRI THEN
                        BEGIN
                            BuildRCalready(rc,kwBRIGHT);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isBRI:=TRUE
                    END
                    ELSE IF Test_Transparent(isTr,trVal,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isTRANS THEN
                        BEGIN
                            BuildRCalready(rc,kwTRANSPARENT);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isTRANS:=TRUE
                    END
                    ELSE IF Test_Texture(tx,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isTEXTURE THEN
                        BEGIN
                            BuildRCalready(rc,kwTEXTURE);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isTEXTURE:=TRUE
                    END
                    ELSE IF Test_SingleBool(kwSHADDOWES,shao,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isSHADDOWES THEN
                        BEGIN
                            BuildRCalready(rc,kwSHADDOWES);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isSHADDOWES:=TRUE
                    END
                    ELSE IF Test_SingleName(kwNAME,nm,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isNAME THEN
                        BEGIN
                            BuildRCalready(rc,kwNAME);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isNAME:=TRUE
                    END                  
                    ELSE BEGIN
                        Test_PARTFIG:=TRUE;
                        Exit
                    END;
                    IF Test_Komma THEN
                        finish:=FALSE
                    ELSE IF Test_ClBr THEN
                        finish:=TRUE
                    ELSE BEGIN
                        BuildRCexpected2(rc,cKomma,cBrCl);
                        Test_PARTFIG:=TRUE;
                        Exit
                    END;
                UNTIL finish;

                IF NOT isTEXTURE THEN
                BEGIN
                    BuildRCmissing(rc,kwTEXTURE);
                    Test_PARTFIG:=TRUE;
                    Exit
                END;

                IF radiusExpected AND NOT isRADIUS THEN
                BEGIN
                    BuildRC(rc,err102);
                    Test_PARTFIG:=TRUE;
                    Exit
                END;

                IF isTYPE AND isVARS THEN
                BEGIN
                    BuildRC(rc,err103);
                    Test_PARTFIG:=TRUE;
                    Exit
                END;

                IF NOT isTYPE AND NOT isVARS THEN
                BEGIN
                    BuildRC(rc,err104);
                    Test_PARTFIG:=TRUE;
                    Exit
                END;

                IF isVARS THEN
                BEGIN
                    radiusExpected:=FALSE;
                    f1:=ff1;
                    f2:=ff2;
                    f3:=ff3;
                    f4:=ff4;
                    f5:=ff5;
                    f6:=ff6;
                    fr:=ffr
                END
                ELSE BEGIN
                    IF figType=kwSPHERE THEN
                    BEGIN
                        radiusExpected:=TRUE;
                        f1:=1;f2:=1;f3:=1;
                        f4:=0;f5:=0;f6:=0;
                        fr:=Sqr(figR);
                    END
                    ELSE IF figType=kwWALL THEN
                    BEGIN
                        radiusExpected:=TRUE;
                        f1:=0;f2:=0;f3:=1;
                        f4:=0;f5:=0;f6:=0;
                        fr:=Sqr(figR);
                    END
                    ELSE IF figType=kwSINGLEWALL THEN
                    BEGIN
                        radiusExpected:=TRUE;
                        f1:=0;f2:=0;f3:=0;
                        f4:=0;f5:=0;f6:=1;
                        fr:=figR;
                    END
                    ELSE IF figType=kwSKY THEN
                    BEGIN
                        radiusExpected:=TRUE;
                        f1:=0;f2:=0;f3:=0;
                        f4:=0;f5:=-1;f6:=0;
                        fr:=-figR;
                    END
                    ELSE IF figType=kwBOTTOM THEN
                    BEGIN
                        radiusExpected:=TRUE;
                        f1:=0;f2:=0;f3:=0;
                        f4:=0;f5:=1;f6:=0;
                        fr:=-figR;
                    END
                    ELSE IF figType=kwBEAM THEN
                    BEGIN
                        radiusExpected:=TRUE;
                        f1:=1;f2:=0;f3:=1;
                        f4:=0;f5:=0;f6:=0;
                        fr:=Sqr(figR);
                    END
                    ELSE IF figType=kwCONE THEN
                    BEGIN
                        radiusExpected:=TRUE;
                        f1:=1;f2:=-figR;f3:=1;
                        f4:=0;f5:=0;f6:=0;
                        fr:=0;
                    END
                    ELSE IF figType=kwHAT THEN
                    BEGIN
                        radiusExpected:=TRUE;
                        f1:=1;f2:=0;f3:=1;
                        f4:=0;f5:=figR;f6:=0;
                        fr:=0;
                    END
                    ELSE BEGIN
                        BuildRCunknown(rc,figType,kwTYPE);
                        Test_PARTFIG:=TRUE;
                        Exit
                    END;
                END;
                f4half:=f4/2;
                f5half:=f5/2;
                f6half:=f6/2;

                IF NOT radiusExpected AND isRADIUS THEN
                BEGIN
                    BuildRC(rc,err105);
                    Test_PARTFIG:=TRUE;
                    Exit
                END;

                IF radiusExpected AND NOT isRADIUS THEN
                BEGIN
                    BuildRCmissing(rc,kwRADIUS);
                    Test_PARTFIG:=TRUE;
                    Exit
                END;


                smoothed:=sm;
                c.x:=mx;
                c.y:=my;
                c.z:=mz;
                Translation(m,mInverse,sx,sy,sz,ta,tb,tc);
                name:=nm;

                isReflection:=isRfl;
                reflectionValue:=reflVal;

                isRefraction:=isRfr;
                refractionValue:=refrVal;
                refractionIndex:=refrInd;

                isShaddowed:=isSha;
                shaddowed:=sha;
                selfshaddow:=ssh;

                isBright:=isBr;
                brightness:=br;
                brightIndex:=brInd;

                isTransparent:=isTr;
                transparencyValue:=trVal;

                shaddowesOthers:=shao;

                texture:=tx;
            END;
            fg:=pSolid;
            error:=FALSE;
            Test_PARTFIG:=TRUE
        END
        ELSE BEGIN
            error:=TRUE;
            kind:=Build;

            IF MaxAvail<SizeOf(BuildFigur) THEN
            BEGIN
                BuildRCmemovl(rc);
                Test_PARTFIG:=TRUE;
                Exit
            END;
            New(pBuild);

            WITH pBuild^ DO
            BEGIN
                IF Test_KEYWORD(kwOR) THEN
                BEGIN
                    smoothFig:=FALSE;
                    operation:=OrOp
                END
                ELSE IF Test_KEYWORD(kwAND) THEN
                BEGIN
                    smoothFig:=FALSE;
                    operation:=AndOp
                END
                ELSE IF Test_KEYWORD(kwANDNOT) THEN
                BEGIN
                    smoothFig:=FALSE;
                    operation:=AndNotOp
                END
                ELSE IF Test_KEYWORD(kwORSMOOTH) THEN
                BEGIN
                    smoothFig:=TRUE;
                    operation:=OrOpSmooth
                END
                ELSE IF Test_KEYWORD(kwANDSMOOTH) THEN
                BEGIN
                    smoothFig:=TRUE;
                    operation:=AndOpSmooth
                END
                ELSE IF Test_KEYWORD(kwANDNOTSMOOTH) THEN
                BEGIN
                    smoothFig:=TRUE;
                    operation:=AndNotOpSmooth
                END
                ELSE BEGIN
                    BuildRC(rc,err106);
                    Test_PARTFIG:=TRUE;
                    Exit
                END;
                IF NOT Parse_OpBr THEN
                BEGIN
                    Test_PARTFIG:=TRUE;
                    Exit
                END;

                isTRANSLATION:=FALSE;
                isSMOOTH:=FALSE;
                isNAME:=FALSE;
                isBOX:=FALSE;

                figCnt:=0;

                mx:=0;
                my:=0;
                mz:=0;
                ta:=0;
                tb:=0;
                tc:=0;
                sx:=1;
                sy:=1;
                sz:=1;
                rSm:=10;
                nm:='?';

                REPEAT
                    IF Test_TRANSLATION(mx,my,mz,ta,tb,tc,sx,sy,sz,TRUE,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isTRANSLATION THEN
                        BEGIN
                            BuildRCalready(rc,kwTRANSLATION);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isTRANSLATION:=TRUE
                    END
                    ELSE IF Test_SINGLE(kwSMOOTH,rSm,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isSMOOTH THEN
                        BEGIN
                            BuildRCalready(rc,kwSMOOTH);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isSMOOTH:=TRUE
                    END
                    ELSE IF Test_SingleName(kwNAME,nm,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isNAME THEN
                        BEGIN
                            BuildRCalready(rc,kwNAME);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isNAME:=TRUE
                    END
                    ELSE IF Test_6Real(kwBox,bxf,bxt,byf,byt,bzf,bzt,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        IF isBOX THEN
                        BEGIN
                            BuildRCalready(rc,kwBOX);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        isBOX:=TRUE
                    END
                    ELSE IF Test_PARTFIG(newKind,newFg,err) THEN
                    BEGIN
                        IF err THEN
                        BEGIN
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        INC(figCnt);
                        IF figCnt>maxPartFig THEN
                        BEGIN
                            BuildRC(rc,err107);
                            Test_PARTFIG:=TRUE;
                            Exit
                        END;
                        figs[figCnt].kind:=newKind;
                        figs[figCnt].fig:=newFg;
                    END
                    ELSE BEGIN
                        Test_PARTFIG:=TRUE;
                        Exit
                    END;
                    IF Test_Komma THEN
                        finish:=FALSE
                    ELSE IF Test_ClBr THEN
                        finish:=TRUE
                    ELSE BEGIN
                        BuildRCexpected2(rc,cKomma,cBrCl);
                        Test_PARTFIG:=TRUE;
                        Exit
                    END;
                UNTIL finish;
                IF figCnt=0 THEN
                BEGIN
                    BuildRC(rc,err108);
                    Test_PARTFIG:=FALSE;
                    Exit
                END;
                IF isSMOOTH AND NOT smoothFig THEN
                BEGIN
                    BuildRC(rc,err109);
                    Test_PARTFIG:=TRUE;
                    Exit
                END;

                rSmooth:=rSm;
                c.x:=mx;
                c.y:=my;
                c.z:=mz;
                Translation(m,mInverse,sx,sy,sz,ta,tb,tc);
                name:=nm;
                IF isBox THEN
                BEGIN
                    box:=TRUE;
                    boxFromX:=bxf;
                    boxToX:=bxt;
                    boxFromY:=byf;
                    boxToY:=byt;
                    boxFromZ:=bzf;
                    boxToZ:=bzt
                END
                ELSE
                    box:=FALSE;
            END;
            fg:=pBuild;
            error:=FALSE;
            Test_PARTFIG:=TRUE
        END;
    END;

    FUNCTION Parse_FIGURES:BOOLEAN;
    VAR res:BYTE;
        name:STRING;
        found:BOOLEAN;
        finish:BOOLEAN;
        i:WORD;
        kind:FigKind;
        fg:POINTER;
        err:BOOLEAN;
    BEGIN
        Scene:=NIL;
        IF NOT Parse_KEYWORD(kwFIGURES) THEN
        BEGIN
            Parse_FIGURES:=FALSE;
            Exit
        END;
        cntF:=0;
        res:=Parse_NAME(name);
        WHILE res=1 DO
        BEGIN
            IF NOT Parse_Eq THEN
            BEGIN
                Parse_FIGURES:=FALSE;
                Exit
            END;

            found:=FALSE;
            FOR i:=1 TO cntF DO
                IF name=Fig[i].fName THEN
                    found:=TRUE;
            IF found THEN
            BEGIN
                BuildRCtwice(rc,name,kwFIGURES);
                Parse_FIGURES:=FALSE;
                EXIT
            END;

            INC(cntF);
            IF cntF>maxFig THEN
            BEGIN
                BuildRCtoomany(rc,kwFIGURES);
                Parse_FIGURES:=FALSE;
                Exit
            END;

            Fig[cntF].fName:=name;
            Fig[cntF].used:=FALSE;
            IF NOT Test_PARTFIG(kind,fg,err) THEN
            BEGIN
                Parse_FIGURES:=FALSE;
                Exit
            END;
            IF err THEN
            BEGIN
                Parse_FIGURES:=FALSE;
                Exit
            END;
            WITH Fig[cntF] DO
            BEGIN
                f.kind:=kind;
                f.fig:=fg
            END;

            IF name=nameScene THEN
            BEGIN
                Fig[cntF].used:=TRUE;
                IF kind=Build THEN
                BEGIN
                    Scene:=fg;
                END
                ELSE BEGIN

                    IF MaxAvail<SizeOf(BuildFigur) THEN
                    BEGIN   
                        BuildRCmemovl(rc);
                        Parse_FIGURES:=FALSE;
                        Exit
                    END;

                    New(Scene);

                    WITH Scene^ DO
                    BEGIN
                        c:=iV;
                        m:=iM;
                        mInverse:=iM;
                        rSmooth:=10;
                        operation:=OrOp;
                        figCnt:=1;
                        figs[1].kind:=Solid;
                        figs[1].fig:=fg
                    END
                END
            END;

            IF NOT Parse_Semikolon THEN
            BEGIN
                Parse_FIGURES:=FALSE;
                Exit
            END;

            res:=Parse_NAME(name);
        END;

        IF res=2 THEN
        BEGIN
            IF Parse_KEYWORD(kwEND) THEN
            BEGIN
                IF Scene<>NIL THEN
                BEGIN
                    Parse_FIGURES:=TRUE;
                    Exit
                END
                ELSE BEGIN
                    BuildRC(rc,err110);
                    Parse_FIGURES:=FALSE;
                    Exit
                END
            END
            ELSE BEGIN
                Parse_FIGURES:=FALSE;
                Exit
            END
        END
        ELSE BEGIN
            Parse_FIGURES:=FALSE;
            Exit
        END
    END;


    FUNCTION Parse_ACTIONS:BOOLEAN;
    VAR finish:BOOLEAN;
        err:BOOLEAN;
        isTRACE:BOOLEAN;
        isTIFF:BOOLEAN;
        isFRAME:BOOLEAN;
        isSCAN:BOOLEAN;
        isPIXELS:BOOLEAN;
        isOVERSAMPLE:BOOLEAN;
        isSWAP:BOOLEAN;
        isSTATE:BOOLEAN;
        isSHOW:BOOLEAN;
        isRESIZE:BOOLEAN;
        isSTEREO:BOOLEAN;

        traceFile:STRING;
        tiffFile:STRING;
        swapDir:STRING;
        pixels:BYTE;
        oversample:BYTE;
        scanx:INTEGER;
        scany:INTEGER;
        scantx:INTEGER;
        scanty:INTEGER;
        framex:INTEGER;
        framey:INTEGER;
        show:STRING;
        state:STRING;
        resize:RealType;
        stereo:BOOLEAN;

    BEGIN
        IF NOT Parse_KEYWORD(kwACTIONS) THEN
        BEGIN
            Parse_ACTIONS:=FALSE;
            Exit
        END;
        isTRACE:=FALSE;
        isTIFF:=FALSE;
        isFRAME:=FALSE;
        isSCAN:=FALSE;
        isPIXELS:=FALSE;
        isOVERSAMPLE:=FALSE;
        isSWAP:=FALSE;
        isSTATE:=FALSE;
        isSHOW:=FALSE;
        isRESIZE:=FALSE;
        isSTEREO:=FALSE;
        resize:=1;
        finish:=FALSE;
        traceFile:='';
        tiffFile:='';
        swapDir:='';
        pixels:=1;
        oversample:=0;
        framex:=319;
        framey:=219;
        scanx:=0;
        scany:=0;
        scantx:=framex;
        scanty:=framey;
        show:='NO';
        state:='NEWPICT';
        stereo:=FALSE;
        REPEAT
            IF Test_SingleString(kwTRACE,traceFile,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                IF isTRACE THEN
                BEGIN
                    BuildRCalready(rc,kwTRACE);
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                isTRACE:=TRUE
            END
            ELSE IF Test_SingleString(kwTIFF,tiffFile,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                IF isTIFF THEN
                BEGIN
                    BuildRCalready(rc,kwTIFF);
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                isTIFF:=TRUE
            END
            ELSE IF Test_SingleBool(kwSTEREO,stereo,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                IF isSTEREO THEN
                BEGIN
                    BuildRCalready(rc,kwSTEREO);
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                isSTEREO:=TRUE
            END
            ELSE IF Test_4Int(kwSCAN,scanx,scany,scantx,scanty,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                IF isSCAN THEN
                BEGIN
                    BuildRCalready(rc,kwSCAN);
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                isSCAN:=TRUE
            END
            ELSE IF Test_2Int(kwFRAME,framex,framey,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                IF isFRAME THEN
                BEGIN
                    BuildRCalready(rc,kwFRAME);
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                isFRAME:=TRUE
            END
            ELSE IF Test_SingleBYTE(kwPIXELS,pixels,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                IF isPIXELS THEN
                BEGIN
                    BuildRCalready(rc,kwPIXELS);
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                isPIXELS:=TRUE
            END
            ELSE IF Test_Single(kwRESIZE,resize,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                IF isRESIZE THEN
                BEGIN
                    BuildRCalready(rc,kwRESIZE);
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                isRESIZE:=TRUE
            END
            ELSE IF Test_SingleBYTE(kwOVERSAMPLE,oversample,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                IF isOVERSAMPLE THEN
                BEGIN
                    BuildRCalready(rc,kwOVERSAMPLE);
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                isOVERSAMPLE:=TRUE
            END
            ELSE IF Test_SingleString(kwSWAP,swapDir,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                IF isSWAP THEN
                BEGIN
                    BuildRCalready(rc,kwSWAP);
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                isSWAP:=TRUE
            END
            ELSE IF Test_SingleNAME(kwSTATE,state,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                IF isSTATE THEN
                BEGIN
                    BuildRCalready(rc,kwSTATE);
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                isSTATE:=TRUE
            END
            ELSE IF Test_SingleNAME(kwSHOW,show,err) THEN
            BEGIN
                IF err THEN
                BEGIN
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                IF isSHOW THEN
                BEGIN
                    BuildRCalready(rc,kwSHOW);
                    Parse_ACTIONS:=FALSE;
                    Exit
                END;
                isSHOW:=TRUE
            END
            ELSE IF Test_KEYWORD(kwEND) THEN
                finish:=TRUE
            ELSE BEGIN
                Parse_ACTIONS:=FALSE;
                Exit
            END;
            IF not finish AND NOT Parse_Semikolon THEN
            BEGIN
                BuildRCexpected(rc,cSemikolon);
                Parse_ACTIONS:=FALSE;
                Exit
            END;

        UNTIL finish;

        glSwap:=swapDir;
        glTrace:=traceFile;
        glTiff:=tiffFile;
        glResize:=resize;
        glStereo:=stereo;
        IF NOT isTIFF THEN
        BEGIN
            BuildRCmissing(rc,kwTIFF);
            Parse_ACTIONS:=FALSE;
            Exit
        END;
        IF (pixels<1) OR (pixels>50) THEN
        BEGIN
            BuildRC(rc,err111);
            Parse_ACTIONS:=FALSE;
            Exit
        END;
        glPixel:=pixels;
        IF isOVERSAMPLE THEN
        BEGIN
            IF (oversample<1) OR (oversample>10) THEN
            BEGIN
                BuildRC(rc,err112);
                Parse_ACTIONS:=FALSE;
                Exit
            END;
            glOversample:=oversample;
        END
        ELSE
            glOversample:=0;
        IF (framex<16) OR (framey<16) OR (framex>16383) OR (framey>16383) THEN
        BEGIN
            BuildRC(rc,err116);
            Parse_ACTIONS:=FALSE;
            Exit
        END;
        IF (scanx>=scantx) OR (scany>=scanty) OR (scanx<0) OR (scany<0) OR (scanx>framex) OR (scany>framey) THEN
        BEGIN
            BuildRC(rc,err113);
            Parse_ACTIONS:=FALSE;
            Exit
        END;
        glScanx:=scanx;
        glScany:=scany;
        glScantx:=scantx;
        glScanty:=scanty;

        glFramex:=framex;
        glFramey:=framey;


        IF (state=kwNEWPICT) THEN
        BEGIN
           glState:=NewPict
        END
        ELSE IF (state=kwREDRAW) THEN
        BEGIN
            glState:=Redraw
        END
        ELSE IF (state=kwDETECT) THEN
        BEGIN
            glState:=Detect
        END
        ELSE IF (state=kwOVERSAMPLE) THEN
        BEGIN
            glState:=Oversamp
        END
        ELSE BEGIN
            BuildRC(rc,err114);
            Parse_ACTIONS:=FALSE;
            Exit
        END;

        IF (show=kwNO) THEN
        BEGIN
            glMode:=0
        END
        ELSE IF (show=kwMODE320) THEN
        BEGIN
            glMode:=1
        END
        ELSE IF (show=kwMODE640) THEN
        BEGIN
            glMode:=6
        END
        ELSE IF (show=kwMODE800) THEN
        BEGIN
            glMode:=9
        END
        ELSE IF (show=kwMODE1024) THEN
        BEGIN
            glMode:=10
        END
        ELSE BEGIN
            BuildRC(rc,err115);
            Parse_ACTIONS:=FALSE;
            Exit
        END;

        Parse_ACTIONS:=TRUE

    END;

    FUNCTION Parse_END:BOOLEAN;
    BEGIN
        IF NOT Parse_KEYWORD(kwEND) THEN
        BEGIN
            Parse_END:=FALSE;
            Exit
        END;
        Parse_END:=TRUE
    END;

BEGIN
    IF verbose THEN
        WriteLn('Parsing...');


    Assign(t,filename);
    Reset(t);
    IOR:=IOResult;
    IF IOR>0 THEN
    BEGIN
        Str(IOR,iorStr);
        rc:='Fehler beim ffnen von '+filename+':rc='+iorStr;
        Parse:=FALSE;
        Exit;
    END;

    lineNr:=0;
    actLine:='';

    IF NOT Parse_SCENE THEN
    BEGIN
        HelpError;
        Parse:=FALSE;
        Exit
    END;

    IF NOT Parse_COLORS THEN
    BEGIN
        HelpError;
        Parse:=FALSE;
        Exit
    END;

    IF NOT Parse_CAMERA THEN
    BEGIN
        HelpError;
        Parse:=FALSE;
        Exit
    END;

    IF NOT Parse_LIGHTS THEN
    BEGIN
        HelpError;
        Parse:=FALSE;
        Exit
    END;

    IF NOT Parse_PICTURES THEN
    BEGIN
        HelpError;
        Parse:=FALSE;
        Exit
    END;

    IF NOT Parse_VECTORTEXTURES THEN
    BEGIN
        HelpError;
        Parse:=FALSE;
        Exit
    END;

    IF NOT Parse_SCALARTEXTURES THEN
    BEGIN
        HelpError;
        Parse:=FALSE;
        Exit
    END;

    IF NOT Parse_FIGURES THEN
    BEGIN
        HelpError;
        Parse:=FALSE;
        Exit
    END;

    IF NOT Parse_ACTIONS THEN
    BEGIN
        HelpError;
        Parse:=FALSE;
        Exit
    END;

    IF NOT Parse_END THEN
    BEGIN
        HelpError;
        Parse:=FALSE;
        Exit
    END;

    Close(t);
    IOR:=IOResult;
    IF IOR>0 THEN
    BEGIN
        Str(IOR,iorStr);
        rc:='Fehler beim Schlieen von '+filename+':rc='+iorStr;
        Parse:=FALSE;
        Exit;
    END;
    rc:='';
    IF verbose THEN
    BEGIN
        GotoXY(1,WhereY);
        Write('          ');
    END;

    Parse:=TRUE
END;


PROCEDURE List;
VAR i:WORD;
    iPos,iPos2,iTrig,iR,iDir,iInd,iDark,iPart,iCol:BOOLEAN;

    PROCEDURE AddTrippleInt(s:STRING;i1,i2,i3:INTEGER);
    VAR s1,s2,s3:STRING;
        i:INTEGER;
    BEGIN
        Str(i1:5,s1);
        Str(i2:5,s2);
        Str(i3:5,s3);
        s:='  '+s+':';
        FOR i:=Length(s) TO 10 DO
            s:=s+' ';
        trace.Add(s+s1+','+s2+','+s3)
    END;

    PROCEDURE AddTrippleReal(s:STRING;r1,r2,r3:RealType);
    VAR s1,s2,s3:STRING;
        i:INTEGER;
    BEGIN
        Str(r1:7:2,s1);
        Str(r2:7:2,s2);
        Str(r3:7:2,s3);
        s:='  '+s+':';
        FOR i:=Length(s) TO 10 DO
            s:=s+' ';
        trace.Add(s+s1+','+s2+','+s3)
    END;

    PROCEDURE AddReal(s:STRING;r:RealType);
    VAR s1,s2,s3:STRING;
        i:INTEGER;
    BEGIN
        Str(r:7:2,s1);
        s:='  '+s+':';
        FOR i:=Length(s) TO 10 DO
            s:=s+' ';
        trace.Add(s+s1)
    END;


    PROCEDURE AddString(s,s1:STRING);
    VAR i:INTEGER;
    BEGIN
        s:='  '+s+':';
        FOR i:=Length(s) TO 10 DO
            s:=s+' ';
        trace.Add(s+s1)
    END;


    PROCEDURE AddStringLevel(s,s1:STRING;level:WORD);
    VAR i:INTEGER;
    BEGIN
        FOR i:=1 TO level DO
           s:='  '+s;
        s:='  '+s+':';
        FOR i:=Length(s) TO 10 DO
            s:=s+' ';
        trace.Add(s+s1)
    END;

    PROCEDURE TraceFig(fig:PBuildFigur;level:WORD);
    VAR i:WORD;
    BEGIN
{$IFDEF FigNames}
        AddStringLevel('Name',fig^.name,level);
{$ENDIF}
        CASE fig^.operation OF
            OrOp:AddStringLevel('Operation','Or',level);
            AndOp:AddStringLevel('Operation','And',level);
            AndNotOp:AddStringLevel('Operation','AndNot',level);
            OrOpSmooth:AddStringLevel('Operation','OrSmooth',level);
            AndOpSmooth:AddStringLevel('Operation','AndSmooth',level);
            AndNotOpSmooth:AddStringLevel('Operation','AndNotSmooth',level)
          ELSE AddStringLevel('Operation','unknown',level);
        END;
        FOR i:=1 TO fig^.figCnt DO
        BEGIN
            WITH fig^.figs[i] DO
                IF kind=Solid THEN
{$IFDEF ObjNames}
                    AddStringLevel('Name',PSolidObject(fig)^.name,SUCC(level))
{$ELSE}
                    AddStringLevel('Name','unknown',SUCC(level))
{$ENDIF}
                ELSE
                    TraceFig(PBuildFigur(fig),SUCC(level))
        END;

    END;

BEGIN
    trace.Add('************ Scene description');
    trace.Add('');
    trace.Add('SCENE:'+nameSCENE);
    trace.Add('');
    trace.Add('');
    trace.Add('COLORS:');
    FOR i:=1 TO cntCOLORS DO
        WITH arCOLORS[i] DO
            IF used THEN
                AddTrippleInt(nameCOLOR,col.r,col.g,col.b);

    WITH Camera DO
    BEGIN
        trace.Add('');
        trace.Add('');
        trace.Add('CAMERA:');
        AddTrippleReal('Pos',x,y,z);
        AddTrippleReal('Ang',alpha/PiDiv180,beta/PiDiv180,gamma/PiDiv180);
    END;

    trace.Add('');
    trace.Add('');
    trace.Add('LIGHTS:');
    FOR i:=1 TO LightCnt DO
        WITH Light[i] DO
        BEGIN
            iPos:=FALSE;iPos2:=FALSE;iTrig:=FALSE;iR:=FALSE;iDir:=FALSE;iInd:=FALSE;iDark:=FALSE;iPart:=FALSE;iCol:=FALSE;

            CASE kind OF
                0:BEGIN
                      trace.Add('  Kind:Normal');
                      iDir:=TRUE;iPart:=TRUE;iCol:=TRUE;

                  END;
                1:BEGIN
                      trace.Add('  Kind:Central');
                      iPos:=TRUE;iDark:=TRUE;iPart:=TRUE;iCol:=TRUE;
                  END;
                2:BEGIN
                      trace.Add('  Kind:Spot');
                      iPos:=TRUE;iDir:=TRUE;iInd:=TRUE;iDark:=TRUE;iPart:=TRUE;iCol:=TRUE;
                  END;
                3:BEGIN
                      trace.Add('  Kind:Stick');
                      iPos:=TRUE;iPos2:=TRUE;iDark:=TRUE;iPart:=TRUE;iCol:=TRUE;
                  END;
                4:BEGIN
                      trace.Add('  Kind:Disk');
                      iPos:=TRUE;iTrig:=TRUE;iR:=TRUE;iDark:=TRUE;iPart:=TRUE;iCol:=TRUE;
                  END;
             ELSE trace.Add('  Kind:unknown')
            END;
            IF iPos THEN
                AddTrippleReal('Pos',c.x,c.y,c.z);
            IF iPos2 THEN
                AddTrippleReal('DPos',d.x,d.y,d.z);
            IF iTrig THEN
            BEGIN
                AddTrippleReal('Sins',sina,sinb,sinc);
                AddTrippleReal('Coss',cosa,cosb,cosc)
            END;
            IF iR THEN
                AddReal('r',r);
            IF iDir THEN
                AddTrippleReal('Dir',l.x,l.y,l.z);
            IF iInd THEN
                AddReal('Ind',index);
            IF iDark THEN
                AddReal('Dark',darkness);
            IF iPart THEN
                AddReal('Part',f);
            IF iCol THEN
                AddTrippleInt('Col',ROUND(LightColor.r),ROUND(LightColor.g),ROUND(LightColor.b));
        trace.Add('')
        END;

    trace.Add('');

    trace.Add('VECTORTEXTURES:');
    FOR i:=1 TO cntVT DO
        WITH vTextures[i] DO
             IF used THEN
             BEGIN
                 AddString('Name',vName);
             END;

    trace.Add('');
    trace.Add('');
    trace.Add('SCALARTEXTURES:');
    FOR i:=1 TO cntST DO
        WITH sTextures[i] DO
             IF used THEN
             BEGIN
                 AddString('Name',sName);
             END;

    trace.Add('');
    trace.Add('');
    trace.Add('SCENEFIGUR:');
    TraceFig(Scene,1);


    trace.Add('');
    trace.Add('');

    trace.Add('************ Scene description end');

END;


END.
