{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,R-,S-,V-}

PROGRAM Prep;

USES Stuff;

CONST includeLevel=4;
      maxMacros=100;
      maxSpace=500;
      maxNameSize=20;
      maxVars=10;

      markStr='***** ';
      macroDefStr='D ';

TYPE PtrSTRING=^STRING;

VAR f:ARRAY[1..includeLevel] OF TEXT;
    dest,list:TEXT;
    sourceFile,destFile,listFile:STRING;
    listFlag:BOOLEAN;

    actLine,actPlay:STRING[255];
    name:ARRAY[1..includeLevel] OF STRING;
    lineNr:ARRAY[1..includeLevel] OF WORD;
    sp:WORD;
    macroDef:BOOLEAN;

    c:CHAR;

    macro:ARRAY[1..maxMacros] OF RECORD
              name:STRING[maxNameSize];
              fromSpace,toSpace:WORD;
          END;
    macroSpace:ARRAY[1..maxSpace] OF PtrSTRING;
    lastMacro:WORD;
    lastSpace:WORD;

    macroMode:BOOLEAN;
    varsp:WORD;
    vars:ARRAY[1..maxVars] OF STRING;
    playVar:STRING;
    playFrom:WORD;
    playTo:WORD;


 

    PROCEDURE FailIOR(IOR:INTEGER;name:STRING;func:STRING);
    VAR err:STRING;
    BEGIN
        IF IOR>0 THEN
        BEGIN
            GetResultString(err,IOR);
            WriteLn('File error with '+name+' function '+func);
            WriteLn(err);
            Halt(1)
        END
    END;


    PROCEDURE Error(txt:STRING);
    BEGIN
        WriteLn(name[sp],'[',linenr[sp]:5,']');
        WriteLn(txt);
        Close(dest);
        IF listFlag THEN
            Close(list);
        Halt(1)
    END;

    PROCEDURE WriteLnList(txt:STRING);
    BEGIN
        IF listFlag THEN
        BEGIN
            IF macroDef THEN
            BEGIN
                WriteLn(list,'');
                WriteLn(list,macroDefStr+txt);
                Write(list,macroDefStr)
            END
            ELSE BEGIN
                WriteLn(list,'');
                WriteLn(list,txt)
            END
        END
    END;

    PROCEDURE WriteList(txt:STRING);
    BEGIN
        IF listFlag THEN
        BEGIN
            Write(list,txt);
            IF macroDef AND (txt=#13) THEN
                Write(list,macroDefStr)
        END
    END;


    FUNCTION PrivateGetC:CHAR;
    BEGIN
        WHILE Length(actLine)=0 DO
        BEGIN
            IF EOF(f[sp]) THEN
            BEGIN
                PrivateGetC:=#1;
                Exit
            END;
            ReadLn(f[sp],actLine);
            actLine:=actLine+#13;
            INC(lineNr[sp]);

            FailIOR(IOResult,name[sp],'ReadLn');
        END;
        PrivateGetC:=actLine[1];
        actLine:=Copy(actLine,2,255)
    END;

    PROCEDURE UngetC(c:CHAR);
    BEGIN
        actLine:=c+actLine
    END;


    PROCEDURE UngetStr(s:STRING);
    BEGIN
        actLine:=s+actLine
    END;


    PROCEDURE KillWhiteBlanks(VAR s:STRING);
    BEGIN
        WHILE (Length(s)>0) AND (s[1]=' ') DO
            Delete(s,1,1);
        WHILE (Length(s)>0) AND (s[Length(s)]=' ') DO
            Delete(s,Length(s),1)
    END;


    PROCEDURE ReadUntil(VAR s:STRING;stopC:CHAR);
    BEGIN
        s:='';
        c:=PrivateGetC;
        WHILE c<>stopC DO
        BEGIN
            IF Length(s)>79 THEN
                Error('no apperance of "'+stopC+'"');
            s:=s+c;
            c:=PrivateGetC
        END
    END;

    PROCEDURE ReadUntil2(VAR s:STRING;stopC1,stopC2:CHAR;VAR theC:CHAR);
    VAR stackP:INTEGER;
    BEGIN
        stackP:=0;
        s:='';
        c:=PrivateGetC;
        WHILE (stackP<>0) OR (c<>stopC1) AND (c<>stopC2) DO
        BEGIN
            IF c='(' THEN
                INC(stackP)
            ELSE IF c=')' THEN
                DEC(stackP);
            IF Length(s)>79 THEN
                Error('no apperance of "'+stopC1+'" OR "'+stopC2+'"');
            s:=s+c;
            c:=PrivateGetC
        END;
        theC:=c
    END;

    FUNCTION AddMacroName(s:STRING):WORD;
    BEGIN
        IF Length(s)>maxNameSize THEN
            Error('macroname '+s+' too long');
        INC(lastMacro);
        IF lastMacro>maxMacros THEN
            Error('macro-name-table overflow');

        INC(lastSpace);
        IF lastSpace>maxSpace THEN
            Error('macro-space overflow');
        WITH macro[lastMacro] DO
        BEGIN
            name:=s;
            fromSpace:=lastSpace;
            toSpace:=lastSpace;
            macroSpace[fromSpace]^:=''
        END;
        AddMacroName:=lastMacro
    END;


    PROCEDURE AddToMacro(handle:WORD;c:CHAR);
    BEGIN
        WITH macro[handle] DO
        BEGIN
            IF Length(macroSpace[toSpace]^)=80 THEN
            BEGIN
                INC(toSpace);
                INC(lastSpace);
                IF lastSpace>maxSpace THEN
                    Error('macro-space overflow');
                macroSpace[toSpace]^:=''
            END;
            macroSpace[toSpace]^:=macroSpace[toSpace]^+c
        END
    END;

    FUNCTION PrivatePlayBack:CHAR;
    BEGIN
        IF Length(playVar)>0 THEN
        BEGIN
            PrivatePlayBack:=playVar[1];
            playVar:=Copy(playVar,2,255);
            Exit
        END;
        WHILE Length(actPlay)=0 DO
        BEGIN
            IF playFrom>=playTo THEN
            BEGIN
                PrivatePlayBack:=#1;
                Exit
            END;
            INC(playFrom);
            actPlay:=macroSpace[playFrom]^;
        END;
        PrivatePlayBack:=actPlay[1];
        actPlay:=Copy(actPlay,2,255)
    END;


    PROCEDURE UngetPrivatePlayBack(c:CHAR);
    BEGIN
        actPlay:=c+actPlay
    END;


    FUNCTION Parse_REAL:REAL;
    VAR c:CHAR;
        negFlag:BOOLEAN;
        aDigit:BOOLEAN;
        fract:REAL;
        r:REAL;
    BEGIN
        r:=0;
        c:=PrivatePlayBack;
        IF c='-' THEN
        BEGIN
            negFlag:=TRUE;
            c:=PrivatePlayBack
        END
        ELSE
            negFlag:=FALSE;
        aDigit:=FALSE;

        WHILE (c>='0') AND (c<='9') DO
        BEGIN
            aDigit:=TRUE;
            r:=r*10+(ORD(c)-ORD('0'));
            c:=PrivatePlayBack
        END;
        IF NOT aDigit THEN
        BEGIN
            Error('illegal char '+c+' in number');
        END;
        IF c='.' THEN
        BEGIN
            fract:=0.1;
            c:=PrivatePlayBack;
            WHILE (c>='0') AND (c<='9') DO
            BEGIN
                r:=r+fract*(ORD(c)-ORD('0'));
                fract:=fract/10;
                c:=PrivatePlayBack
            END;
        END;
        UngetPrivatePlayBack(c);
        IF negFlag THEN
            r:=-r;
        Parse_REAL:=r
    END;




    FUNCTION ReadExpr:REAL;
    VAR c,c1,c2:CHAR;
        nrStr:STRING;
        code:INTEGER;
        nr:REAL;
        nr1,nr2:REAL;

    BEGIN
        c:=PrivatePlayBack;
        IF c='@' THEN
            c:=PrivatePlayBack;
        IF c='(' THEN
        BEGIN
            nr1:=ReadExpr;
            c1:=PrivatePlayBack;
            nr2:=ReadExpr;
            c2:=PrivatePlayBack;
            IF (c2<>')') THEN
                Error('")" expected in expression');
            IF (c1='+') THEN
                ReadExpr:=nr1+nr2
            ELSE IF (c1='-') THEN
                ReadExpr:=nr1-nr2
            ELSE IF (c1='*') THEN
                ReadExpr:=nr1*nr2
            ELSE IF (c1='/') THEN
            BEGIN
                IF nr2=0 THEN
                    Error('division by zero');
                ReadExpr:=nr1/nr2
            END
        END
        ELSE IF c='$' THEN
        BEGIN
            c:=PrivatePlayBack;
            IF (c<'1') OR (c>'9') THEN
                Error('illegal macro variable:"'+c+'"');
            IF (ORD(c)-ORD('0'))>varsp THEN
                Error('variable not determined');
            nrStr:=vars[ORD(c)-ORD('0')];
            Val(nrStr,nr,code);
            IF code>0 THEN
                Error('illegal number for var '+nrStr);
            ReadExpr:=nr
        END
        ELSE BEGIN
            UngetPrivatePlayBack(c);
            ReadExpr:=Parse_REAL
        END
    END;


    FUNCTION PlayBack:CHAR;
    VAR c:CHAR;
        nr:REAL;
        nrInt:LONGINT;
    BEGIN
        IF macroDef AND (Length(playVar)>0) THEN
            PlayBack:=PrivatePlayBack
        ELSE BEGIN
            c:=PrivatePlayBack;
            IF (c='$') THEN
            BEGIN
                c:=PrivatePlayBack;
                IF (c<'1') OR (c>'9') THEN
                    Error('illegal macro variable:"'+c+'"');
                IF (ORD(c)-ORD('0'))>varsp THEN
                    Error('variable not determined');
                playVar:=vars[ORD(c)-ORD('0')];
                PlayBack:=PrivatePlayBack
            END
            ELSE IF NOT macrodef AND (c='@') THEN
            BEGIN
                nr:=ReadExpr;
                nrInt:=TRUNC(nr);
                IF ABS(nr-nrInt)<1e-10 THEN
                    Str(nrInt,playVar)
                ELSE
                    Str(nr:20:10,playVar);
                PlayBack:=PrivatePlayBack
            END
            ELSE
                PlayBack:=c
        END
    END;


    FUNCTION GetC:CHAR;
    VAR cs:STRING;
        s:STRING;
        handle:WORD;
        c:CHAR;
    BEGIN
        IF macroMode THEN
        BEGIN
            c:=PlayBack;
            IF c<>#1 THEN
            BEGIN
                GetC:=c;
                Exit
            END
            ELSE BEGIN
                WriteLnList(markStr+'End Macrocall ');
                macroMode:=FALSE
            END
        END;
        c:=PrivateGetC;
        IF c=#1 THEN
        BEGIN
            IF sp=1 THEN
            BEGIN
                GetC:=c;
                Exit
            END;
            Close(f[sp]);
            FailIOR(IOResult,name[sp],'Close');
            WriteLnList(markStr+'End Include '+name[sp]);
            DEC(sp);
            GetC:=PrivateGetC;
            Exit
        END;
        IF c<>'[' THEN
        BEGIN
            GetC:=c;
            Exit
        END;
        cs:=PrivateGetC+PrivateGetC;
        IF cs='I ' THEN
        BEGIN
            ReadUntil(s,']');
            KillWhiteBlanks(s);
            IF sp=includeLevel THEN
                Error('Too many include-levels');
            INC(sp);
            WriteLnList(markStr+'Begin Include '+s);
            Assign(f[sp],s);
            name[sp]:=s;
            lineNr[sp]:=0;
            Reset(f[sp]);
            FailIOR(IOResult,name[sp],'Reset');
            GetC:=PrivateGetC;
            Exit
        END
        ELSE IF cs='M ' THEN
        BEGIN

            ReadUntil(s,'=');
            KillWhiteBlanks(s);
            WriteLnList(markStr+'Begin Macrodef '+s);
            macroDef:=TRUE;
            handle:=AddMacroName(s);
            c:=GetC;
            WHILE c<>']' DO
            BEGIN
                WriteList(c);
                AddToMacro(handle,c);
                c:=GetC
            END;
            macroDef:=FALSE;
            WriteLnList(markStr+'End Macrodef '+s);
            GetC:=PrivateGetC;
            Exit
        END
        ELSE BEGIN
            UngetStr(cs);
            ReadUntil(s,'(');
            KillWhiteBlanks(s);
            handle:=1;
            WHILE (handle<lastMacro) AND (macro[handle].name<>s) DO
                INC(handle);
            IF macro[handle].name<>s THEN
                Error('['+s+' unknown macro or directive');
            varsp:=0;
            WriteLnList(markStr+'Begin Macrocall '+s);
            REPEAT
                ReadUntil2(s,',',')',c);
                KillWhiteBlanks(s);
                IF s<>'' THEN
                BEGIN
                    INC(varsp);
                    IF varsp>maxVars THEN
                        Error('too many vars in macro');
                    vars[varsp]:=s
                END;
            UNTIL c=')';
            c:=PrivateGetC;
            IF c<>']' THEN
                Error('"'+c+'":"]" expected to close macro call');
            macroMode:=TRUE;
            playFrom:=macro[handle].fromSpace;
            playTo:=macro[handle].toSpace;
            actPlay:=macroSpace[playFrom]^;
            playVar:='';
            GetC:=PlayBack
        END
    END;

    PROCEDURE GetMems;
    VAR i:WORD;
    BEGIN
        FOR i:=1 TO maxSpace DO
           NEW(macroSpace[i]);
    END;

    PROCEDURE DisposeMems;
    VAR i:WORD;
    BEGIN
        FOR i:=1 TO maxSpace DO
           DISPOSE(macroSpace[i]);
    END;


BEGIN
    listFlag:=FALSE;
    IF ParamCount=0 THEN
    BEGIN
        Write('Scource File:');
        ReadLn(sourceFile);
        Write('Dest File:');
        ReadLn(destFile);
        Write('List File:');
        ReadLn(listFile);
        IF listFile<>'' THEN
            listFlag:=TRUE;
    END
    ELSE IF ParamCount>=2 THEN
    BEGIN
        sourceFile:=ParamStr(1);
        destFile:=ParamStr(2);
        IF ParamCount=3 THEN
        BEGIN
            listFile:=ParamStr(3);
            listFlag:=TRUE
        END
    END
    ELSE BEGIN
        WriteLn('Usage PREP <sourcefile> <destfile> [<listfile>]');
        WriteLn('Direcives:');
        WriteLn(' [I <filename>]               : Include File');
        WriteLn(' [M <macroname>=<macrotext>]  : Macrodefinition with $1..$9 vars');
        WriteLn(' [<macroname>(<var>,<var>..)] : Call a macro');
        Halt(1)
    END;


    Assign(f[1],sourceFile);
    Assign(dest,destFile);
    Reset(f[1]);
    FailIOR(IOResult,sourceFile,'Reset');
    ReWrite(dest);
    FailIOR(IOResult,destFile,'ReWrite');

    IF listFlag THEN
    BEGIN
        Assign(list,listFile);
        ReWrite(list);
        FailIOR(IOResult,listFile,'ReWrite');
    END;

    GetMems;

    actLine:='';

    lastMacro:=0;
    lastSpace:=0;

    macroMode:=FALSE;


    sp:=1;
    name[1]:=sourceFile;
    lineNr[1]:=0;
    macroDef:=FALSE;

    c:=GetC;
    WriteList(c);
    WHILE c<>#1 DO
    BEGIN
        Write(dest,c);
        c:=GetC;
        WriteList(c)

    END;

    DisposeMems;

    Close(f[1]);
    FailIOR(IOResult,sourceFile,'Close');
    Close(dest);
    FailIOR(IOResult,destFile,'Close');
    IF listFlag THEN
    BEGIN
        Close(list);
        FailIOR(IOResult,listFile,'Close')
    END
END.
