{$A+,B-,D+,E-,F+,G+,I-,L+,N+,O-,R+,S-,V-}
{$DEFINE PROFILERx}

UNIT Raytrace;

INTERFACE

USES CRT,Stuff,VM,Maths,Graph,Extragraph,Messages,Basis,
     Cameras,Lights,Intervalls,Textures,SolidObjects,Figures
{$IFDEF PROFILER}
     ,Profiler
{$ENDIF}
     ;


CONST
      NewPict=0;   (*** Alles Neu            ***)
      Detect=1;    (*** Bild weiterberechnen ***)
      Redraw=2;    (*** Teil neuberechnen    ***)
      Oversamp=3;  (*** Nur Oversamplen      ***)


TYPE cell=RECORD
         z:RealType;
         col:RGBColor;
     END;

VAR Scene:PBuildFigur;

    aCell:cell;
    v:virtualMemory;

PROCEDURE ComputePicture(FromX,FromY,ToX,ToY:INTEGER;Size:INTEGER;
                         swapDir:STRING;NewSwap:BYTE;grafic:BOOLEAN;VAR userexit:BOOLEAN);
(*** Berechnet ein Bild.                                                                    ***)

PROCEDURE ComputePictureRGHolo(FromX,FromY,ToX,ToY:INTEGER;Size:INTEGER;
                               swapDir:STRING;NewSwap:BYTE;grafic:BOOLEAN;VAR userexit:BOOLEAN);
(*** Berechnet ein Bild mit Rot-Grn-Holoeffekt                                             ***)


PROCEDURE Oversample(FromX,FromY,ToX,ToY:INTEGER;Oversampling:BYTE;
                     ff:RealType;swapDir:STRING;grafic:BOOLEAN;VAR userexit:BOOLEAN);
(*** Macht eine Kantennachberechnung. Oversampling gibt dabei die Kantenlnge des Quadrates ***)
(*** an, das nachberechnet werden soll. ff ist ein Faktor, der angibt bei welcher Farbdif-  ***)
(*** ferenz eine Nachberechung stattfinden soll (1: normal, je grer desto seltener)       ***)

PROCEDURE OversampleRGHolo(FromX,FromY,ToX,ToY:INTEGER;Oversampling:BYTE;
                           ff:RealType;swapDir:STRING;grafic:BOOLEAN;VAR userexit:BOOLEAN);
(*** dto fr Rot-Grn-Holo                                                                  ***)

IMPLEMENTATION

CONST dx=1024;
      dy=2;
      pages=2;


FUNCTION InShade(VAR minP,li:Vector3;maxL:RealType):BOOLEAN;
VAR i:INTEGER;
    resultIntervall:IntervallSet;
    seeobj:BOOLEAN;
    p1,p2:RealType;
    npx1,npy1,npz1,nx1,ny1,nz1:RealType;
    npx2,npy2,npz2,nx2,ny2,nz2:RealType;

BEGIN
    Vresize(li,-1);
    Scene^.GetIntervall(minP,li,resultIntervall);
    seeobj:=FALSE;
    i:=1;
    WITH resultIntervall DO
        WHILE (i<=cnt) DO
            WITH block[i].iFrom DO
                IF PSolidObject(obj)^.shaddowesOthers AND (l>0) AND (l<maxL)  THEN
                BEGIN
                    InShade:=TRUE;
                    Exit
                END
                ELSE
                    INC(i);

    InShade:=FALSE
END;


PROCEDURE CalcShade(VAR col1:RGBfloat;minObj:PSolidObject;minP,newR,minN:Vector3);
CONST ShadeCnt:ARRAY[0..4] OF INTEGER=
           (0,0,0,  (* 0..2 keine Anzahl notwendig *)
            8,      (* Stablicht                   *)
           100);    (* Scheibenlicht               *)
      ShadeDepth:ARRAY[0..4] OF INTEGER=
           (0,0,0,  (* 0..2 keine Anzahl notwendig *)
            8,      (* Stablicht                   *)
           10);     (* Scheibenlicht               *)


VAR lights,shadeI:INTEGER;
    scolx:RGBfloat;
    shadeF:RealType;
{### nderung 19.4.96:gestrichen:
    ssum:RealType;
}

    maxL:RealType;
    li:Vector3;

    InShade0,InShade1:BOOLEAN;
    midF:RealType;
    midCnt:INTEGER;
    CntShade:RealType;
    testShade,startShade,endShade:RealType;
    shadeD:INTEGER;

    intensity:RealType;
    lightCol:RGBfloat;

    scol,scol2:RGBfloat;
    mainShaddow:BOOLEAN;
    shaddowVal1:RealType;
    SC:INTEGER;

    ssf,ffr,ffg,ffb,fcopy:RealType;
    ddd:RealType;
    minNnorm:Vector3;

BEGIN
{$IFDEF PROFILER}
     BeginIt(9);
{$ENDIF}
    WITH minObj^ DO
    BEGIN

(******************************************************)
(*                                                    *)
(* Diese Figur erhlt normale Schattenberechnung      *)
(*                                                    *)
(******************************************************)

        Vnorm(minN,minNnorm);

        scolx:=RGB0;
{### nderung 19.4.96:gestrichen:
        ssum:=0;
}
        FOR lights:=1 TO LightCnt DO
        BEGIN
            IF smoothed AND ((Light[lights].kind=LightStick) OR (Light[lights].kind=LightDisk)) THEN

(******************************************************)
(*                                                    *)
(* Lichtquelle ist stab- oder scheibenfrmig          *)
(* und wird "smoothed" berechnet                      *)
(*                                                    *)
(******************************************************)

            BEGIN
                GetLight(lights,TRUE,0,minP,newR,li,maxL,intensity,shadeF,lightCol);
                GetLightColor(li,minNnorm,selfshaddow,
                              mainShaddow,ddd);

                RGBresize(col1,scol,ddd);

                shaddowVal1:=intensity;

                InShade0:=mainShaddow OR InShade(minP,li,maxL);
                CntShade:=0;
                startShade:=0;
                SC:=ShadeCnt[Light[lights].kind];
                FOR shadeI:=1 TO SC DO
                BEGIN
                    testShade:=(shadeI)/SC;
                    GetLight(lights,TRUE,testShade,minP,newR,
                             li,maxL,intensity,shadeF,lightCol);
                    GetLightColor(li,minNnorm,selfshaddow,
                                  mainShaddow,ddd);

                    RGBresize(scol2,col1,ddd);

                    InShade1:=mainShaddow OR InShade(minP,li,maxL);
                    IF InShade1 THEN
                    BEGIN
                        IF NOT InShade0 THEN
                        BEGIN
                            startShade:=testShade-0.5/SC;
                            midF:=0.25/SC;
                            FOR shadeD:=1 TO ShadeDepth[Light[lights].kind] DO
                            BEGIN
                                GetLight(lights,TRUE,startShade,minP,newR,
                                         li,maxL,intensity,shadeF,lightCol);
                                GetLightColor(li,minNnorm,selfshaddow,
                                              mainShaddow,ddd);

                                RGBresize(scol2,col1,ddd);

                                IF mainShaddow OR InShade(minP,li,maxL) THEN
                                    startShade:=startShade-midF
                                ELSE
                                    startShade:=startShade+midF;
                                midF:=midF/2
                            END
                        END
                    END
                    ELSE BEGIN
                        IF InShade0 THEN
                        BEGIN
                            endShade:=((shadeI-0.5)/SC);
                            midF:=0.25/SC;
                            FOR shadeD:=1 TO ShadeDepth[Light[lights].kind] DO
                            BEGIN
                                GetLight(lights,TRUE,endShade,minP,newR,
                                         li,maxL,intensity,shadeF,lightCol);
                                GetLightColor(li,minNnorm,selfshaddow,
                                              mainShaddow,ddd);

                                RGBresize(scol2,col1,ddd);

                                IF mainShaddow OR InShade(minP,li,maxL) THEN
                                    endShade:=endShade+midF
                                ELSE
                                    endShade:=endShade-midF;
                                midF:=midF/2
                            END;
                            CntShade:=CntShade+endShade-startShade;
                        END
                    END;
                    InShade0:=InShade1
                END;
                IF InShade1 THEN
                    CntShade:=CntShade+(1-startShade);
                shaddowVal1:=shaddowVal1*(1-CntShade);

                IF shaddowVal1<1 THEN
                BEGIN
                    shaddowVal1:=shaddowed+(1-shaddowed)*shaddowVal1;
                    RGBresizeSelf(scol,shaddowVal1)
                END
            END
            ELSE BEGIN

(******************************************************)
(*                                                    *)
(* Lichtquelle ist punktfrmig oder parallel          *)
(* oder wird nicht "smoothed" berechnet- dann wird    *)
(* jeweils der Mittelpunkt des Stabes oder der Scheibe*)
(* als Lichtquelle angenommen                         *)
(*                                                    *)
(******************************************************)

                GetLight(lights,FALSE,0,minP,newR,li,maxL,intensity,shadeF,lightCol);
                GetLightColor(li,minNnorm,selfshaddow,
                              mainShaddow,ddd);
                shaddowVal1:=intensity;
{
                IF NOT mainShaddow THEN
                    IF InShade(minP,li,maxL) THEN
                        shaddowVal1:=0;
}
                IF mainShaddow OR InShade(minP,li,maxL) THEN
                    shaddowVal1:=0;

                shaddowVal1:=ddd*(shaddowed+(1-shaddowed)*shaddowVal1);
                RGBresize(col1,scol,shaddowVal1)
            END;
{### nderung 19.4.96:gestrichen:
            ssum:=ssum+shadeF;
}
            ssf:=shaddowed;
            ffr:=(lightCol.r+(255-lightCol.r)*ssf)*cRez255;
            ffg:=(lightCol.g+(255-lightCol.g)*ssf)*cRez255;
            ffb:=(lightCol.b+(255-lightCol.b)*ssf)*cRez255;
{### nderung 19.4.96:gestrichen:
            scolx.r:=scolx.r+scol.r*shadeF*ffr;
            scolx.g:=scolx.g+scol.g*shadeF*ffg;
            scolx.b:=scolx.b+scol.b*shadeF*ffb;
}
{ stattdessen: }
            fcopy:=scol.r*shadeF*ffr;
            IF fcopy>scolx.r THEN
                scolx.r:=fcopy;
            fcopy:=scol.g*shadeF*ffg;
            IF fcopy>scolx.g THEN
                scolx.g:=fcopy;
            fcopy:=scol.b*shadeF*ffb;
            IF fcopy>scolx.b THEN
                scolx.b:=fcopy
        END;
{ ### nderung 19.4.96:gestrichen:
        RGBresize(scolx,col1,1/ssum)
}
{ stattdessen: }
        col1:=scolx
    END
{$IFDEF PROFILER}
    ;EndIt(9)
{$ENDIF}

END;





PROCEDURE GetColor(p,r:Vector3;f:RealType;
                   VAR col:RGBfloat;VAR o:Vector3);

CONST minF=0.05;    (* Reizschwelle, ab der nicht weitergetraced wird *)
      prf=0.01;     (* Gibt an bei durchsichtig, wie tief weitergetraced wird *)

VAR col1,col2,col3,col4:RGBfloat;
    resultIntervall:IntervallSet;
    minP,minN:Vector3;
    minL:RealType;
    minTexture:PVectorTexture;
    minObj:PSolidObject;
    minseeobj:BOOLEAN;

    reflection,refraction:RealType;

    newR:Vector3;
    sumrr:RealType;
    li:Vector3;

    i:WORD;
    lightI:WORD;
    maxL:RealType;
    intensity:RealType;
    shadeF:RealType;
    lightCol:RGBfloat;
    dummy:Vector3;

    refrSeeobj:BOOLEAN;
    refrP,refrN:Vector3;

    pp:Vector3;
    pr:RealType;

    col123:RGBfloat;


BEGIN

(******************************************************)
(*                                                    *)
(* Wenn zu tief verschachtelt wird Rekursion abgebro- *)
(* chen und als Entfernung unendlich, sowie als Farbe *)
(* schwarz zurckgeliefert.                           *)
(*                                                    *)
(******************************************************)

    IF f<minF THEN
    BEGIN
        col:=RGB0;
        o.x:=infinite;
        o.y:=infinite;
        o.z:=infinite;
        Exit
    END;

    col1:=RGB0;
    col2:=RGB0;
    col3:=RGB0;
    col4:=RGB0;

(******************************************************)
(*                                                    *)
(* Suche nchstes Objekt, speichere Daten in          *)
(*  minseeobj:Ist berhaupt ein Objekt zu sehen       *)
(*  minP:Enfernungsfaktor                             *)
(*  minp:Auftreffpunnkt                               *)
(*  minn:Normale im Auftreffpunkt                     *)
(*  minTexture:Textur                                 *)
(*                                                    *)
(*                                                    *)
(******************************************************)

    Scene^.GetIntervall(p,r,resultIntervall);
    minseeobj:=FALSE;
    i:=1;
    WITH resultIntervall DO
        WHILE (i<=cnt) AND NOT minseeobj DO
            WITH block[i].iFrom DO
                IF l>0.001 THEN
                BEGIN
                    minseeobj:=TRUE;
                    minL:=l;
                    minP.x:=p.x+r.x*l;
                    minP.y:=p.y+r.y*l;
                    minP.z:=p.z+r.z*l;
                    minN:=n;
                    minObj:=PSolidObject(obj);
                    minTexture:=minObj^.texture
                END
                ELSE
                    INC(i);

    IF minseeobj THEN
    BEGIN

(******************************************************)
(*                                                    *)
(* Wenn Figur zu sehen, hole zuerst Farbe der Textur  *)
(* in col1.                                           *)
(*                                                    *)
(******************************************************)

        WITH minObj^ DO
        BEGIN

            o:=minP;

            IF (isReflection) THEN
                reflection:=reflectionValue^.getValue(minP)
            ELSE
                reflection:=0;

            IF (isRefraction) THEN
                refraction:=refractionValue^.getValue(minP)
            ELSE
                refraction:=0;

            sumrr:=(refraction+reflection);

            minTexture^.getValues(minP,minN,col1);

            mirrLine(minN,r,newR);

            IF (sumrr<1) THEN
            BEGIN

(******************************************************)
(*                                                    *)
(* Berechne Faktor fr Schatten und Glanz.            *)
(*                                                    *)
(******************************************************)

                IF isShaddowed THEN
                BEGIN
{@@@ erst nicht
                    IF smoothedFrame THEN
                    BEGIN

(******************************************************)
(*                                                    *)
(* Diese Figur erhlt keine normale Schattenber.      *)
(* es wird der Schatten aus einem Feld interpoliert   *)
(*                                                    *)
(******************************************************)

                        scolx:=RGB0;

                        ssum:=0;
                        ReScanSurface(relx,rely,minpx,minpy,minpz);
                        startix:=ROUND(relx*maxFrame)-radFrame;
                        IF startix<0 THEN
                            startix:=0;
                        endix:=ROUND(relx*maxFrame)+radFrame;
                        IF endix>maxFrame THEN
                            endix:=maxFrame;
                        startiy:=ROUND(rely*maxFrame)-radFrame;
                        IF startiy<0 THEN
                            startiy:=0;
                        endiy:=ROUND(rely*maxFrame)+radFrame;
                        IF endiy>maxFrame THEN
                            endiy:=maxFrame;
                        FOR ix:=startix TO endix DO
                            FOR iy:=startiy TO endiy DO
                                WITH frame^[ix,iy] DO
                                BEGIN
                                    dx:=ABS(relx*maxFrame-ix);
                                    dy:=ABS(rely*maxFrame-iy);
                                    IF (dx<radFrame) AND (dy<radFrame) THEN
                                    BEGIN
                                        dx:=(Power(radFrame-dx,3));
                                        IF dx<0 THEN
                                            dx:=0;
                                        dy:=(Power(radFrame-dy,3));
                                        IF dy<0 THEN
                                            dy:=0;
                                        shadeF:=dx*dy
                                    END
                                    ELSE
                                        shadeF:=0;
                                    scolx.r:=scolx.r+shaddowCol.r*shadeF;
                                    scolx.g:=scolx.g+shaddowCol.g*shadeF;
                                    scolx.b:=scolx.b+shaddowCol.b*shadeF;
                                    ssum:=ssum+shadeF
                                END;
                        RGBresize(scolx.r,col1,1/ssum)
                    END


                    ELSE
@@@}
(******************************************************)
(*                                                    *)
(* Diese Figur erhlt normale Schattenberechnung      *)
(*                                                    *)
(******************************************************)

                         CalcShade(col1,minObj,minP,newR,minN);
                END;
                IF (isBright) THEN
                BEGIN
                    FOR lightI:=1 TO LightCnt DO
                    BEGIN
                        GetLight(lightI,FALSE,0,minP,newR,li,maxL,intensity,shadeF,lightCol);
                        GetBrightColor(li,newR,brightness*intensity*shadeF,brightIndex,
                                       lightCol,col1,col1);
                    END
                END

            END;


(******************************************************)
(*                                                    *)
(* Wenn Reflektion berechne reflektiertes Farbe in    *)
(* col2                                               *)
(*                                                    *)
(******************************************************)

            IF isReflection THEN
            BEGIN
                GetColor(minP,newR,reflection*f,col2,dummy);
            END;

(******************************************************)
(*                                                    *)
(* Wenn Brechung berechne zuerst Brechstrahl und dann *)
(* Farbe dahinter in col3.                            *)
(*                                                    *)
(******************************************************)

            IF isRefraction THEN
            BEGIN
                refractLine(minN,
                            r,
                            refractionIndex,
                            newR);

                Scene^.GetIntervall(minP,newR,resultIntervall);
                refrSeeobj:=FALSE;
                i:=1;
                WITH resultIntervall DO
                    WHILE (i<=cnt) AND NOT refrSeeobj DO
                        WITH block[i].iFrom DO
                            IF (minObj=PSolidObject(obj)) AND (ABS(l)<0.001) THEN
                            BEGIN
                                refrSeeobj:=TRUE;
                                WITH block[i].iTo DO
                                BEGIN
                                    refrP.x:=minP.x+newR.x*l;
                                    refrP.y:=minP.y+newR.y*l;
                                    refrP.z:=minP.z+newR.z*l;
                                    refrN:=n
                                END
                            END
                            ELSE
                                INC(i);

                IF NOT refrSeeObj THEN
                    GetColor(minP,newR,refraction*f,
                             col3,dummy)
                ELSE BEGIN
                    refractLine(refrN,
                                newR,
                                1/refractionIndex,
                                newR);
                    GetColor(refrP,newR,refraction*f,
                             col3,dummy)
                END
            END;

(******************************************************)
(*                                                    *)
(* Wenn durchsichtig, berechne Farbe dahinter in col4 *)
(*                                                    *)
(******************************************************)

            IF isTransparent THEN
            BEGIN
                pr:=transparencyValue^.getValue(minP);
                pp.x:=minP.x+r.x*prf;
                pp.y:=minP.y+r.y*prf;
                pp.z:=minP.z+r.z*prf;
                GetColor(pp,r,(1-pr)*f,
                         col4,dummy)
            END
            ELSE
                pr:=1;

(******************************************************)
(*                                                    *)
(* Aus den 4 Farben col1..col4 sowie den Faktoren     *)
(* reflection, refraction und pr erzeuge Farbe col    *)
(*                                                    *)
(******************************************************)

            IF sumrr>=1 THEN
            BEGIN
                col123.r:=(reflection*col2.r+refraction*col3.r)/sumrr;
                col123.g:=(reflection*col2.g+refraction*col3.g)/sumrr;
                col123.b:=(reflection*col2.b+refraction*col3.b)/sumrr;
            END
            ELSE BEGIN
                col123.r:=(1-sumrr)*col1.r+reflection*col2.r+refraction*col3.r;
                col123.g:=(1-sumrr)*col1.g+reflection*col2.g+refraction*col3.g;
                col123.b:=(1-sumrr)*col1.b+reflection*col2.b+refraction*col3.b;
            END;

            RGBpartition(col4,col123,col,pr)

        END
    END

(******************************************************)
(*                                                    *)
(* Es war kein Objekt zu sehen: Farbe wird schwarz,   *)
(* Entfernung unendlich.                              *)
(*                                                    *)
(******************************************************)

    ELSE BEGIN
        col:=RGB0;
        o.x:=infinite;
        o.y:=infinite;
        o.z:=infinite;
        Exit
    END

(******************************************************)
(*                                                    *)
(*                                                    *)
(*                                                    *)
(*                                                    *)
(******************************************************)
END;


PROCEDURE ComputePicture(FromX,FromY,ToX,ToY:INTEGER;Size:INTEGER;
                         swapDir:STRING;NewSwap:BYTE;grafic:BOOLEAN;VAR userexit:BOOLEAN);
VAR x,y,sx,sy:INTEGER;
    p,r,o:Vector3;
    col:RGBfloat;
    i,j:INTEGER;
    Time:LONGINT;
    TimeStr,Ystr:STRING[10];
    yact,ycnt:INTEGER;
    swapping:BOOLEAN;
    VMR:INTEGER;
    colInt:RGBColor;

 
BEGIN
    userexit:=FALSE;
    aCell.z:=infinite*2;
    swapping:=(swapDir<>'');
    IF swapping THEN
    BEGIN
        IF NewSwap=NewPict THEN
        BEGIN
            ReWriteVM(v,(ToX-FromX)+1,(ToY-FromY)+1,SizeOf(cell),@aCell,dx,dy,pages,swapDir);
            VMR:=VMResult;
            IF VMR>0 THEN
            BEGIN
                trace.add('Error Rewriting VM');
                userexit:=TRUE;
                Exit
            END;
        END
        ELSE BEGIN
            ResetVM(v,swapDir);
            VMR:=VMResult;
            IF VMR>0 THEN
            BEGIN
                trace.add('Error Reseting VM');
                userexit:=TRUE;
                Exit
            END;
            IF NewSwap=Detect THEN
            BEGIN
                GetVM(v,0,FromY,@aCell);
                WHILE (FromY<ToY) AND (aCell.z<infinite*1.5) DO
                BEGIN
                    INC(FromY);
                    GetVM(v,0,FromY,@aCell)
                END;
                DEC(FromY);
            END
        END
    END;

    IF grafic THEN
    BEGIN
        SetFillStyle(SolidFill,255);
        Bar(ROUND(GetMaxX/Frame.GetMaxX*FromX),ROUND(GetMaxY/Frame.GetMaxY*FromY),
            ROUND(GetMaxX/Frame.GetMaxX*ToX),ROUND(GetMaxY/Frame.GetMaxY*ToY));
        SetTextJustify(0,2);
        SetTextStyle(0,0,0)
    END;

    sx:=Size;
    sy:=Size;
    y:=FromY;
    ycnt:=SUCC(ROUND((ToY-FromY)/size));
    yact:=0;
    WHILE (y<=ToY) AND NOT KeyPressed DO
    BEGIN
        StartStopWatch(1);
        x:=FromX;
        WHILE x<=ToX DO
        BEGIN

            Calc3D(x,y,p.x,p.y,p.z,r.x,r.y,r.z);
            GetColor(p,r,1,col,o);
            copyRGBfloat(col,colInt);


            IF swapping THEN
            BEGIN
                aCell.col:=colInt;
                aCell.z:=(SQR(o.x-p.x)+SQR(o.y-p.y)+SQR(o.z-p.z))/
                         (SQR(r.x)+SQR(r.y)+SQR(r.z))*screen;
                PutVM(v,x,y,@aCell)
            END;

            IF grafic THEN
            BEGIN

                FOR i:=0 TO sx DO
                    FOR j:=0 TO sy DO
                        DithPutPixel(ROUND(GetMaxX/Frame.GetMaxX*(x+i)),ROUND(GetMaxY/Frame.GetMaxY*(y+j)),
                                     colInt.r DIV 4,colInt.g DIV 4,colInt.b DIV 4)
            END;
            x:=x+sx
        END;
        y:=y+sy;
        INC(yact);
        time:=ROUND(GetStopWatch(1)*(ycnt-yact));
        Str(ROUND(y):3,Ystr);
        GetHMinSecStr(Time,FALSE,TimeStr);

        IF grafic THEN
        BEGIN
            ClearArea(0,GetMaxY-11,110,11);
            OutTextXY(2,GetMaxY-9,TimeStr+'/'+YStr)
        END
        ELSE BEGIN
            GotoXY(1,WhereY);
            Write(TimeStr+'/'+YStr)
        END;
    END;
    IF KeyPressed THEN
        userexit:=TRUE;
    IF swapping THEN
        CloseVM(v)
END;


PROCEDURE ComputePictureRGHolo(FromX,FromY,ToX,ToY:INTEGER;Size:INTEGER;
                               swapDir:STRING;NewSwap:BYTE;grafic:BOOLEAN;VAR userexit:BOOLEAN);
VAR x,y,sx,sy:INTEGER;
    p,r,o:Vector3;
    col,col1,col2:RGBfloat;
    i,j:INTEGER;
    Time:LONGINT;
    TimeStr,Ystr:STRING[10];
    yact,ycnt:INTEGER;
    swapping:BOOLEAN;


    greycol:INTEGER;
    VMR:INTEGER;

    colInt,colInt1,colInt2:RGBColor;
    zsave:RealType;

BEGIN
    userexit:=FALSE;
    aCell.z:=infinite*2;
    swapping:=(swapDir<>'');
    IF swapping THEN
    BEGIN
        IF NewSwap=NewPict THEN
        BEGIN
            ReWriteVM(v,(ToX-FromX)+1,(ToY-FromY)+1,SizeOf(cell),@aCell,dx,dy,pages,swapDir);
            VMR:=VMResult;
            IF VMR>0 THEN
            BEGIN
                trace.add('Error Rewriting VM');
                userexit:=TRUE;
                Exit
            END
        END
        ELSE BEGIN
            ResetVM(v,swapDir);
            VMR:=VMResult;
            IF VMR>0 THEN
            BEGIN
                trace.add('Error Reseting VM');
                userexit:=TRUE;
                Exit
            END;

            IF NewSwap=Detect THEN
            BEGIN
                GetVM(v,0,FromY,@aCell);
                WHILE (FromY<ToY) AND (aCell.z<infinite*1.5) DO
                BEGIN
                    INC(FromY);
                    GetVM(v,0,FromY,@aCell)
                END;
                DEC(FromY);
            END
        END
    END;

    IF grafic THEN
    BEGIN
        SetFillStyle(SolidFill,255);
        Bar(ROUND(GetMaxX/Frame.GetMaxX*FromX),ROUND(GetMaxY/Frame.GetMaxY*FromY),
            ROUND(GetMaxX/Frame.GetMaxX*ToX),ROUND(GetMaxY/Frame.GetMaxY*ToY));
        SetTextJustify(0,2);
        SetTextStyle(0,0,0)
    END;
    sx:=Size;
    sy:=Size;
    y:=FromY;
    ycnt:=SUCC(ROUND((ToY-FromY)/size));
    yact:=0;
    WHILE (y<=ToY) AND NOT KeyPressed DO
    BEGIN
        StartStopWatch(1);
        x:=FromX;
        WHILE x<=ToX DO
        BEGIN

            Calc3DEye1(x,y,p.x,p.y,p.z,r.x,r.y,r.z);
            GetColor(p,r,1,col1,o);
            copyRGBfloat(col1,colInt1);

            greycol:=(LONGINT(colInt1.r)*3+colInt1.g*2+colInt1.b) DIV 6;

            colInt1.r:=greycol;
            colInt1.g:=greycol;
            colInt1.b:=greycol;

            Calc3DEye2(x,y,p.x,p.y,p.z,r.x,r.y,r.z);
            GetColor(p,r,1,col2,o);
            copyRGBfloat(col2,colInt2);

            greycol:=(LONGINT(colInt2.r)*3+colInt2.g*2+colInt2.b) DIV 6;

            colInt2.r:=greycol;
            colInt2.g:=greycol;
            colInt2.b:=greycol;

            colInt.r:=colInt1.r;
            colInt.g:=colInt2.g DIV 2;
            colInt.b:=colInt2.g;

            IF swapping THEN
            BEGIN
                aCell.col:=colInt;
                aCell.z:=(SQR(o.x-p.x)+SQR(o.y-p.y)+SQR(o.z-p.z))/
                         (SQR(r.x)+SQR(r.y)+SQR(r.z))*screen;
                PutVM(v,x,y,@aCell)
            END;

            IF grafic THEN
                FOR i:=0 TO sx DO
                    FOR j:=0 TO sy DO
                        DithPutPixel(ROUND(GetMaxX/Frame.GetMaxX*(x+i)),ROUND(GetMaxY/Frame.GetMaxY*(y+j)),
                                     colInt.r DIV 4,colInt.g DIV 4,colInt.b DIV 4);
            x:=x+sx
        END;
        y:=y+sy;
        INC(yact);
        time:=ROUND(GetStopWatch(1)*(ycnt-yact));
        Str(ROUND(y):3,Ystr);
        GetHMinSecStr(Time,FALSE,TimeStr);

        IF grafic THEN
        BEGIN
            ClearArea(0,GetMaxY-11,110,11);
            OutTextXY(2,GetMaxY-9,TimeStr+'/'+YStr)
        END
        ELSE BEGIN
            GotoXY(1,WhereY);
            Write(TimeStr+'/'+YStr)
        END
    END;
    IF KeyPressed THEN
        userexit:=TRUE;
    IF swapping THEN
        CloseVM(v)
END;




PROCEDURE Oversample(FromX,FromY,ToX,ToY:INTEGER;Oversampling:BYTE;
                     ff:RealType;swapDir:STRING;grafic:BOOLEAN;VAR userexit:BOOLEAN);
VAR x,y,SuccX,SuccY:INTEGER;
    col1,col2,col3,col4:RGBColor;
    maxr,minr,maxg,ming,maxb,minb:LONGINT;
    ox,oy:INTEGER;
    od:RealType;
    redsum,greensum,bluesum:LONGINT;
    SqrO:LONGINT;
    p,r,o:Vector3;
    col:RGBfloat;
    colInt:RGBColor;
    Time:LONGINT;
    TimeStr,Ystr:STRING[10];
    VMR:INTEGER;
    zsave:RealType;
BEGIN

    userexit:=FALSE;
    IF KeyPressed THEN
    BEGIN
        userexit:=TRUE;
        Exit
    END;

    IF swapDir='' THEN
        Exit;

    ResetVM(v,swapDir);
    VMR:=VMResult;
    IF VMR>0 THEN
    BEGIN
        trace.add('Error Reseting VM');
        userexit:=TRUE;
        Exit
    END;

    od:=1/Oversampling;
    SqrO:=Sqr(Oversampling);

    IF grafic THEN
    BEGIN
        SetFillStyle(SolidFill,255);
        Bar(ROUND(GetMaxX/Frame.GetMaxX*FromX),ROUND(GetMaxY/Frame.GetMaxY*FromY),
            ROUND(GetMaxX/Frame.GetMaxX*ToX),ROUND(GetMaxY/Frame.GetMaxY*ToY))
    END;


    FOR y:=FromY TO ToY DO
    BEGIN
        StartStopWatch(1);

        FOR x:=FromX TO ToX DO
        BEGIN

            SuccX:=SUCC(x);
            IF SuccX>ToX THEN
                SuccX:=ToX;

            SuccY:=SUCC(y);
            IF SuccY>ToY THEN
                SuccY:=ToY;

            IF KeyPressed THEN
            BEGIN
                CloseVM(v);
                userexit:=TRUE;
                Exit
            END;

            GetVM(v,x,y,@aCell);
            col1:=aCell.col;
            zsave:=aCell.z;
            GetVM(v,SuccX,y,@aCell);
            col2:=aCell.col;
            GetVM(v,x,SuccY,@aCell);
            col3:=aCell.col;
            GetVM(v,SuccX,SuccY,@aCell);
            col4:=aCell.col;

            maxr:=max4I(col1.r,col2.r,col3.r,col4.r);
            minr:=min4I(col1.r,col2.r,col3.r,col4.r);
            maxg:=max4I(col1.g,col2.g,col3.g,col4.g);
            ming:=min4I(col1.g,col2.g,col3.g,col4.g);
            maxb:=max4I(col1.b,col2.b,col3.b,col4.b);
            minb:=min4I(col1.b,col2.b,col3.b,col4.b);

            IF ((maxr-minr)>26/2*ff) OR
               ((maxg-ming)>20/2*ff) OR
               ((maxb-minb)>40/2*ff) THEN
            BEGIN
                redsum:=0;
                greensum:=0;
                bluesum:=0;
                FOR ox:=0 TO PRED(Oversampling) DO
                    FOR oy:=0 TO PRED(Oversampling) DO
                    BEGIN
                        Calc3D(x+ox*od,y+oy*od,p.x,p.y,p.z,r.x,r.y,r.z);
                        GetColor(p,r,1,col,o);
                        copyRGBfloat(col,ColInt);
                        redsum:=redsum+colInt.r;
                        greensum:=greensum+colInt.g;
                        bluesum:=bluesum+colInt.b
                    END;
                colInt.r:=redsum DIV SqrO;
                colInt.g:=greensum DIV SqrO;
                colInt.b:=bluesum DIV SqrO;
                aCell.col:=colInt;
                aCell.z:=zsave;
                PutVM(v,x,y,@aCell);
                IF grafic THEN
                BEGIN
                    DithPutPixel(ROUND(GetMaxX/Frame.GetMaxX*x),ROUND(GetMaxY/Frame.GetMaxY*y),
                                 colInt.r DIV 4,colInt.g DIV 4,colInt.b DIV 4);
                    DithPutPixel(ROUND(GetMaxX/Frame.GetMaxX*x),ROUND(GetMaxY/Frame.GetMaxY*y),
                                 63,63,63)
                END
            END
            ELSE
                IF grafic THEN
                    DithPutPixel(ROUND(GetMaxX/Frame.GetMaxX*x),ROUND(GetMaxY/Frame.GetMaxY*y),
                                 col1.r DIV 4,col1.g DIV 4,col1.b DIV 4);

        END;
        time:=ROUND(GetStopWatch(1)*(Toy-y));
        Str(ROUND(y):3,Ystr);
        GetHMinSecStr(Time,FALSE,TimeStr);
        IF grafic THEN
        BEGIN
            ClearArea(0,GetMaxY-11,110,11);
            OutTextXY(2,GetMaxY-9,TimeStr+'/'+YStr)
        END
        ELSE BEGIN
            GotoXY(1,WhereY);
            Write(TimeStr+'/'+YStr)
        END

    END;
    CloseVM(v)
END;


PROCEDURE OversampleRGHolo(FromX,FromY,ToX,ToY:INTEGER;Oversampling:BYTE;
                           ff:RealType;swapDir:STRING;grafic:BOOLEAN;VAR userexit:BOOLEAN);
VAR x,y,SuccX,SuccY:INTEGER;
    col1,col2,col3,col4:RGBColor;
    greycol:INTEGER;
    maxr,minr,maxg,ming,maxb,minb:LONGINT;
    ox,oy:INTEGER;
    od:RealType;
    redsum,greensum,bluesum:LONGINT;
    SqrO:LONGINT;
    p,r,o:Vector3;
    col:RGBColor;
    colf1,colf2:RGBfloat;
    colInt,colInt1,colInt2:RGBColor;
    Time:LONGINT;
    TimeStr,Ystr:STRING[10];
    VMR:INTEGER;
    zsave:RealType;
BEGIN
    userexit:=FALSE;
    IF KeyPressed THEN
    BEGIN
        userexit:=TRUE;
        Exit
    END;

    IF swapDir='' THEN
        Exit;

    ResetVM(v,swapDir);
    VMR:=VMResult;
    IF VMR>0 THEN
    BEGIN
        trace.add('Error Reseting VM');
        userexit:=TRUE;
        Exit
    END;

    od:=1/Oversampling;
    SqrO:=Sqr(Oversampling);

    IF grafic THEN
    BEGIN
        SetFillStyle(SolidFill,255);
        Bar(ROUND(GetMaxX/Frame.GetMaxX*FromX),ROUND(GetMaxY/Frame.GetMaxY*FromY),
            ROUND(GetMaxX/Frame.GetMaxX*ToX),ROUND(GetMaxY/Frame.GetMaxY*ToY))
    END;

    FOR y:=FromY TO ToY DO
    BEGIN
        StartStopWatch(1);

        FOR x:=FromX TO ToX DO
        BEGIN
            SuccX:=SUCC(x);
            IF SuccX>ToX THEN
                SuccX:=ToX;

            SuccY:=SUCC(y);
            IF SuccY>ToY THEN
                SuccY:=ToY;

            IF KeyPressed THEN
            BEGIN
                CloseVM(v);
                userexit:=TRUE;
                Exit
            END;

            GetVM(v,x,y,@aCell);
            col1:=aCell.col;
            zsave:=aCell.z;
            GetVM(v,SuccX,y,@aCell);
            col2:=aCell.col;
            GetVM(v,x,SuccY,@aCell);
            col3:=aCell.col;
            GetVM(v,SuccX,SuccY,@aCell);
            col4:=aCell.col;

            maxr:=max4I(col1.r,col2.r,col3.r,col4.r);
            minr:=min4I(col1.r,col2.r,col3.r,col4.r);
            maxg:=max4I(col1.g,col2.g,col3.g,col4.g);
            ming:=min4I(col1.g,col2.g,col3.g,col4.g);
            maxb:=max4I(col1.b,col2.b,col3.b,col4.b);
            minb:=min4I(col1.b,col2.b,col3.b,col4.b);

            IF ((maxr-minr)>26/2*ff) OR
               ((maxg-ming)>20/2*ff) OR
               ((maxb-minb)>40/2*ff) THEN
            BEGIN
                redsum:=0;
                greensum:=0;
                bluesum:=0;
                FOR ox:=0 TO PRED(Oversampling) DO
                    FOR oy:=0 TO PRED(Oversampling) DO
                    BEGIN

                        Calc3DEye1(x,y,p.x,p.y,p.z,r.x,r.y,r.z);
                        GetColor(p,r,1,colf1,o);
                        copyRGBfloat(colf1,colInt1);

                        greycol:=(LONGINT(colInt1.r)*3+colInt1.g*2+colInt1.b) DIV 6;

                        colInt1.r:=greycol;
                        colInt1.g:=greycol;
                        colInt1.b:=greycol;

                        Calc3DEye2(x,y,p.x,p.y,p.z,r.x,r.y,r.z);
                        GetColor(p,r,1,colf2,o);
                        copyRGBfloat(colf2,colInt2);

                        greycol:=(LONGINT(colInt2.r)*3+colInt2.g*2+colInt2.b) DIV 6;

                        colInt2.r:=greycol;
                        colInt2.g:=greycol;
                        colInt2.b:=greycol;

                        colInt.r:=colInt1.r;
                        colInt.g:=colInt2.g DIV 2;
                        colInt.b:=colInt2.g;

                        redsum:=redsum+colInt.r;
                        greensum:=greensum+colInt.g;
                        bluesum:=bluesum+colInt.b
                    END;
                colInt.r:=redsum DIV SqrO;
                colInt.g:=greensum DIV SqrO;
                colInt.b:=bluesum DIV SqrO;

                aCell.col:=colInt;
                aCell.z:=zsave;
                PutVM(v,x,y,@aCell);
                IF grafic THEN
                BEGIN
                    DithPutPixel(ROUND(GetMaxX/Frame.GetMaxX*x),ROUND(GetMaxY/Frame.GetMaxY*y),
                                 colInt.r DIV 4,colInt.g DIV 4,colInt.b DIV 4);
                    DithPutPixel(ROUND(GetMaxX/Frame.GetMaxX*x),ROUND(GetMaxY/Frame.GetMaxY*y),
                                 63,63,63);
                END
            END
            ELSE
                IF grafic THEN
                    DithPutPixel(ROUND(GetMaxX/Frame.GetMaxX*x),ROUND(GetMaxY/Frame.GetMaxY*y),
                                 col1.r DIV 4,col1.g DIV 4,col1.b DIV 4)

        END;
        time:=ROUND(GetStopWatch(1)*(Toy-y));
        Str(ROUND(y):3,Ystr);
        GetHMinSecStr(Time,FALSE,TimeStr);

        IF grafic THEN
        BEGIN
            ClearArea(0,GetMaxY-11,110,11);
            OutTextXY(2,GetMaxY-9,TimeStr+'/'+YStr)
        END
        ELSE BEGIN
            GotoXY(1,WhereY);
            Write(TimeStr+'/'+YStr)
        END
    END;
    CloseVM(v)
END;

END.
