{$A+,B-,D+,E-,F+,G+,I-,L+,N+,O-,R-,S-,V-}
{$M 65000,0,655360}
{$DEFINE PROFILERx}

PROGRAM RT;

USES CRT,Graph,ExtraGraph,Stuff,VM,TIFF,Basis,Cameras,Lights,
     Textures,SolidObjects,Intervalls,Figures,Models,Raytrace,Messages,Parser
{$IFDEF PROFILER}
     ,Profiler
{$ENDIF}
     ;


VAR BGIError,nr:INTEGER;
    Mode:INTEGER;
    grafic:BOOLEAN;

    rc:STRING;

    TimeStr:STRING;
    nrStr:STRING;
    userexit:BOOLEAN;

    sceneFile:STRING;




PROCEDURE TSENG256;
EXTERNAL;
(*$L TSENG256.obj *)


(*$F+*)
FUNCTION AutoDetect:INTEGER;
BEGIN
    AutoDetect:=Mode
END;
(*$F-*)


PROCEDURE Swap2Tiff(swapDir,tiffFile:STRING;cntX,cntY:INTEGER;VAR userexit:BOOLEAN);
VAR VMR,IOR:INTEGER;
    f:FILE;
    i,j:INTEGER;
BEGIN
    userexit:=FALSE;

{    ResetVMP(v,swapDir,6);  }
    ResetVM(v,swapDir);

    VMR:=VMResult;
    IF VMR>0 THEN
    BEGIN
        userexit:=TRUE;
        trace.add('Error Reseting VM');
        Exit
    END;

    Assign(f,tiffFile);
    ReWrite(f,1);

    IOR:=IOResult;
    IF IOR>0 THEN
    BEGIN
        userexit:=TRUE;
        trace.add('Error ReWriting '+tiffFile);
        Exit
    END;

    IOR:=MakeTiffHeader(f,cntX,cntY,FALSE);

    WriteLn;
    WriteLn('Converting:');

    FOR j:=0 TO PRED(cntY) DO
    BEGIN
        GotoXY(2,WhereY);
        Write(j/PRED(cntY)*100:5:1,' %');
        FOR i:=0 TO PRED(cntX) DO
        BEGIN
            GetVM(v,i,j,@aCell);
            WITH aCell.col DO
                IOR:=SaveTIFFRGBPixel(f,r,g,b);
        END
    END;
    IOR:=CloseTiffPict(f);
    CloseVM(v)
END;


BEGIN

    (*$IFOPT N+*)
        ASM
           FINIT
        END;
    (*$ENDIF*)


    {$IFDEF PROFILER}
    InitProfiler;
    AddProcedure(1,'NotOp');
    AddProcedure(2,'OrOp');
    AddProcedure(3,'AndOp');
    AddProcedure(4,'AndNotOp');
    AddProcedure(5,'Solid.GetInterval');
    AddProcedure(6,'Build.GetInterval');
    AddProcedure(7,'VTexture.GetValues');
    AddProcedure(8,'STexture.GetValues');
    AddProcedure(9,'CalcShade');

    {$ENDIF}


    IF ParamCount=0 THEN
    BEGIN
        Write('Scene file:');
        ReadLn(sceneFile)
    END
    ELSE IF ParamCount=1 THEN
        sceneFile:=ParamStr(1)
    ELSE BEGIN
        WriteLn('Usage RT <scenefile>');
        Halt(1);
    END;
    IF sceneFile='' THEN
        Halt(1);

    IF Parse(sceneFile,rc) THEN
    BEGIN
        WriteLn;
        WriteLn('Parsing OK');
        WriteLn;
    END
    ELSE BEGIN
        WriteLn;
        WriteLn('Parsing Error:'+rc);
        ReadLn;
        Halt(1)
    END;
    trace.Start(glTrace);
    List;

    SetFrame(glFramex,glFramey);
    ResizePict(glResize);

    IF glMode>0 THEN
    BEGIN

        grafic:=TRUE;
        nr:=InstallUserDriver('TSENG256',@AutoDetect);
        BGIerror:=RegisterBGIDriver(@TSENG256);
        Mode:=glMode;  (*** Bei 1:Im 320*200 Modus lufts auch unter OS/2 im Hintergrund ***)
                       (*** Sonst 10 ***)

        InitGraphScreen;
        GraphScreen;
        MakeDithPalette
    END
    ELSE
        grafic:=FALSE;

    trace.Add('');
    trace.Add('');

    Str(Memavail,nrStr);
    trace.Add('Memavail:'+nrStr);
    Str(Maxavail,nrStr);
    trace.Add('Maxavail:'+nrStr);

    IF glState<>Oversamp THEN
    BEGIN

        trace.Add('************ Raytracing');
        StartStopWatch(2);
        StartStopWatch(3);
        IF glStereo THEN
            ComputePictureRGHolo(glScanx,glScany,glScantx,glScanty,glPixel,glSwap,glState,grafic,userexit)
        ELSE
            ComputePicture(glScanx,glScany,glScantx,glScanty,glPixel,glSwap,glState,grafic,userexit);

        GetHMinSecStr(GetStopWatch(2),FALSE,TimeStr);
        IF userexit THEN
            trace.Add('************ Raytracing aborted in '+TimeStr)
        ELSE
            trace.Add('************ Raytracing complete in '+TimeStr);
    END;

    IF glOversample>0 THEN
    BEGIN
        trace.Add('');
        trace.Add('');
        trace.Add('************ Oversampling');
        StartStopWatch(2);
        IF glStereo THEN
            OversampleRGHolo(glScanx,glScany,glScantx,glScanty,glOversample,1,glSwap,grafic,userexit)
        ELSE
            Oversample(glScanx,glScany,glScantx,glScanty,glOversample,1,glSwap,grafic,userexit);
        GetHMinSecStr(GetStopWatch(2),FALSE,TimeStr);
        IF userexit THEN
            trace.Add('************ Oversampling abortet in '+TimeStr)
        ELSE
            trace.Add('************ Oversampling complete in '+TimeStr);
    END;

    IF grafic THEN
    BEGIN
        IF NOT userexit THEN
            ReadLn;
        TextScreen
    END;

    IF NOT userexit THEN
    BEGIN
        trace.Add('');
        trace.Add('');
        trace.Add('************ Tiff-converting');
        StartStopWatch(2);
        Swap2Tiff(glSwap,glTiff,SUCC(glFramex),SUCC(glFramey),userexit);
        GetHMinSecStr(GetStopWatch(2),FALSE,TimeStr);
        IF userexit THEN
            trace.Add('************ Tiff-converting abortet in '+TimeStr)
        ELSE
            trace.Add('************ Tiff-converting complete in '+TimeStr);
    END;

    trace.Add('');
    trace.Add('');

    GetHMinSecStr(GetStopWatch(3),FALSE,TimeStr);

    IF userexit THEN
    BEGIN
        trace.Add('************ Picture aborted in '+TimeStr);
        WriteLn;
        WriteLn('Picture aborted')
    END
    ELSE BEGIN
        trace.Add('************ Picture complete in '+TimeStr);
        WriteLn;
        WriteLn('Picture complete')
    END;

    TraceIntervallStats;

    trace.Stop

    {$IFDEF PROFILER}
    ;ExitProfiler;
    {$ENDIF}

END.
